#include "ba0.h"

#define Ts "[this, is, a, test]"
#define Tq "[2/3, -1/4, 0, -27, 101/421]"

int main ()
{
    ba0_tableof_string T;
    ba0_tableof_mpq Q;
    struct ba0_mark M;
    static char buffer [1024];
    int i;
    bool b;

    ba0_restart (0, 0);
    ba0_record (&M);

    T = (ba0_tableof_string)ba0_new_table ();
    Q = (ba0_tableof_mpq)ba0_new_table ();

    ba0_sscanf2 (Ts, "%t[%s]", T);
    ba0_sscanf2 (Tq, "%t[%q]", Q);
 
    b = true;
    for (i = 0; i < 3 && b; i++)
    {	ba0_sprintf (buffer, "%t[%s]", T);
	b = strcmp (buffer, Ts) == 0;
	if (i == 1)
	    ba0_alloc (100);
	ba0_sprintf (buffer, "%t[%q]", Q);
	b = b && strcmp (buffer, Tq) == 0;
	ba0_garbage ("%t[%s]%t[%q]", &M, &T, &Q);
    }

    ba0_insert_table ((ba0_table)Q, 2, Q->tab [4]);
    ba0_sprintf (buffer, "%t[%q]", Q);
    b = b && strcmp (buffer, "[2/3, -1/4, 101/421, 0, -27, 101/421]") == 0;
    ba0_insert_table ((ba0_table)Q, 6, Q->tab [4]);
    ba0_sprintf (buffer, "%t[%q]", Q);
    b = b && strcmp (buffer, "[2/3, -1/4, 101/421, 0, -27, 101/421, -27]") == 0;
    ba0_terminate (ba0_init_level);
    return b ? 0 : 1;
}

