#include "ba0.h"

static bool isder (char* s)
{
    return strcmp (s, "t") == 0;
}

int main ()
{   
    struct ba0_mark M;
    ba0_indexed indexed;
    char buffer [256];
    bool lder;

    ba0_restart (0, 0);
    ba0_record (&M);

    ba0_set_analex_string ("x[t]");
    ba0_get_token_analex ();
    indexed = ba0_scanf_indexed (0, &lder, &isder);
    ba0_set_output_string (buffer);
    ba0_printf_indexed (indexed);
    if (lder == false || strcmp (buffer, "x[t]") != 0)
	return 1;

    ba0_set_analex_string ("x[t](u)");
    ba0_get_token_analex ();
    indexed = ba0_scanf_indexed (0, &lder, &isder);
    ba0_set_output_string (buffer);
    ba0_printf_indexed (indexed);
    if (lder == true || strcmp (buffer, "x[t](u)") != 0)
        return 1;

    ba0_set_analex_string ("x[t,u]");
    ba0_get_token_analex ();
    indexed = ba0_scanf_indexed (0, &lder, &isder);
    ba0_set_output_string (buffer);
    ba0_printf_indexed (indexed);
    if (lder == true || strcmp (buffer, "x[t,u]") != 0)
	return 1;

    ba0_garbage ("%indexed", &M, &indexed);
    ba0_set_output_string (buffer);
    ba0_printf_indexed (indexed);
    if (strcmp (buffer, "x[t,u]") != 0)
        return 1;

    return 0;
}
