#include "ba0.h"

int main ()
{
#ifdef HAVE_MPFR_H

    ba0_tableof_mpfr T;
    ba0_arrayof_mpfr A;
    struct ba0_mark M;
    char buffer [128];
    bool b;

    ba0_restart (0, 0);
    ba0_record (&M);
    ba0_alloc (1);
    T = (ba0_tableof_mpfr)ba0_new_table ();
    ba0_sscanf2 ("[3, .24, 2.17, 5e4, 7e-3, -8700e-1, -11]", "%t[%fr]", T);
    ba0_garbage ("%t[%fr]", &M, &T);
    ba0_sprintf (buffer, "%t[%fr]", T);
    b = T->size == 7 &&
	mpfr_cmp_d (T->tab [0], 3.) == 0 &&
	mpfr_cmp_d (T->tab [1], .24) == 0 &&
	mpfr_cmp_d (T->tab [2], 2.17) == 0 &&
	mpfr_cmp_d (T->tab [3], 5e4) == 0 &&
	mpfr_cmp_d (T->tab [4],  7e-3) == 0 &&
	mpfr_cmp_d (T->tab [5], -8700e-1) == 0 &&
	mpfr_cmp_d (T->tab [6], -11) == 0;
    ba0_alloc (1);

    A = (ba0_arrayof_mpfr)ba0_new_array ();
    ba0_sscanf2 ("[3, .24, 2.17, 5e4, 7e-3, -8700e-1, -11]", "%a[%fr]", A);
    ba0_garbage ("%a[%fr]", &M, &A);
    ba0_sprintf (buffer, "%a[%fr]", A);
    b = A->size == 7 &&
	mpfr_cmp_d (&A->tab [0], 3.) == 0 &&
	mpfr_cmp_d (&A->tab [1], .24) == 0 &&
	mpfr_cmp_d (&A->tab [2], 2.17) == 0 &&
	mpfr_cmp_d (&A->tab [3], 5e4) == 0 &&
	mpfr_cmp_d (&A->tab [4],  7e-3) == 0 &&
	mpfr_cmp_d (&A->tab [5], -8700e-1) == 0 &&
	mpfr_cmp_d (&A->tab [6], -11) == 0;
    ba0_terminate (ba0_init_level);
    return b ? 0 : 1;

#else

    return 0;

#endif
}
