#include "ba0.h"

int main ()
{   struct ba0_stack H;
    struct ba0_exception_code code;
    void* cell;
    char *s;

    ba0_restart (0, 0);
    cell = (void*)malloc (20);
    ba0_init_one_cell_stack (&H, "local stack", cell, 20);
    ba0_push_stack (&H);
    s = ba0_strdup ("abcd");
    ba0_pull_stack ();
    ba0_clear_one_cell_stack (&H);
    ba0_terminate (ba0_init_level);
    if ((void*)s != cell || strcmp (s, "abcd") != 0)
	return 1;
    free (cell);

    ba0_restart (0, 0);
    cell = (void*)malloc (4);
    ba0_init_one_cell_stack (&H, "local stack", cell, 4);
    ba0_push_stack (&H);
    BA0_PUSH_EXCEPTION (code);
    if (ba0_exception_is_set (code))
    {   s = ba0_strdup ("abcd");
	return 1;
    } else if (ba0_mesgerr != BA0_ERROOM)
	return 1;

    ba0_pull_stack ();
    ba0_clear_one_cell_stack (&H);
    ba0_terminate (ba0_init_level);
    free (cell);

    return 0;
}
