#ifndef BAD_POSITION_H 
#define BAD_POSITION_H 1

#include "bad_common.h"

BEGIN_C_DECLS

enum bad_typeof_case { bad_none_case, bad_first_case, bad_factor_case, 
		       bad_regularisation_case, bad_splitting_case, 
		       bad_euclid_case };

typedef struct bad_position {
    ba0_int_p index;
    ba0_int_p number;
    enum bad_typeof_case type;
} *bad_position;

typedef struct bad_tableof_position {
    ba0_int_p alloc;
    ba0_int_p size;
    bad_position* tab;
} *bad_tableof_position;

extern BAD_DLL void bad_init_position (bad_position);
extern BAD_DLL bad_position bad_new_position (void);
extern BAD_DLL void bad_set_position (bad_position, bad_position);
extern BAD_DLL void bad_set_position_values
			(bad_position, enum bad_typeof_case, 
			 ba0_int_p, ba0_int_p);

extern BAD_DLL ba0_scanf_function bad_scanf_position;
extern BAD_DLL ba0_printf_function bad_printf_position;
extern BAD_DLL ba0_garbage1_function bad_garbage1_position;
extern BAD_DLL ba0_garbage2_function bad_garbage2_position;
extern BAD_DLL ba0_copy_function bad_copy_position;

extern BAD_DLL void bad_realloc_tableof_position
			(bad_tableof_position, ba0_int_p);
extern BAD_DLL void bad_set_tableof_position 
			(bad_tableof_position, bad_tableof_position);
extern BAD_DLL void bad_append_tableof_position
			(bad_tableof_position, bad_tableof_position,
			 enum bad_typeof_case, ba0_int_p, ba0_int_p);

END_C_DECLS

#endif /* !BAD_POSITION_H */
