#include "bad.h"

int main ()
{   struct bad_splitting_control control;
    struct bad_base_field K;
    struct bad_regchain A;
    struct bad_intersectof_regchain T;
    struct bav_tableof_variable S;
    bav_Iordering r;
    struct bap_tableof_polynom_mpz eqns, ineqns;
    static char buffer [512];
    bool b = true;

    bad_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [], blocks = [u, x, y])",
		 "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_init_table ((ba0_table)&eqns);
    ba0_sscanf2 ("[(x+1)*u^2 + u - 1, x^2 - y]", "%t[%Az]", &eqns);
    ba0_init_table ((ba0_table)&ineqns);

    bad_init_intersectof_regchain (&T);
    ba0_sscanf2 ("intersectof_regchain ([], [autoreduced, primitive, squarefree, normalized])", "%intersectof_regchain", &T);

    bad_init_splitting_control (&control);
    bad_set_dimension_lower_bound_splitting_control 
			(&control, bad_no_dimension_lower_bound, true);

    bad_Rosenfeld_Groebner (&T, &eqns, &ineqns, (bad_base_field)0, &control);

    ba0_sprintf (buffer, "%intersectof_regchain_equations", &T);
    b = strcmp (buffer, "[[x^2 - y, u^2*y - u^2 + u*x - u - x + 1], [y - 1, x + 1, u - 1], [16*y - 25, 4*x + 5, u - 2], [y, x, u^2 + u - 1]]") == 0 ||
	strcmp (buffer, "[[x^2 - y, u^2*y - u^2 + u*x - u - x + 1], [16*y - 25, 4*x + 5, u - 2], [y - 1, x + 1, u - 1], [y, x, u^2 + u - 1]]") == 0;

    bad_init_base_field (&K);
    bad_init_regchain (&A);
    ba0_sscanf2 ("regchain ([x^2 - y], [autoreduced, primitive, squarefree, normalized])", "%pretend_regchain", &A);
    bad_set_base_field_generators_and_relations 
	(&K, (bav_tableof_variable)0, &A, (bav_tableof_parameter)0, true, false);

    ba0_init_table ((ba0_table)&S);
    bad_base_field_implicit_generators (&S, &K, 0, &A);
    ba0_sprintf (buffer, "%t[%v]", &S);
    b = b && strcmp (buffer, "[]") == 0;

    bad_Rosenfeld_Groebner (&T, &eqns, &ineqns, &K, (bad_splitting_control)0);

    ba0_sprintf (buffer, "%intersectof_regchain_equations", &T);
/*
 * Old test. 
 * The second equation is not normalized wrt to the base field equation

    b = b && strcmp (buffer, "[[x^2 - y, u^2*x + u^2 + u - 1]]") == 0;

 * Compare with the new result. 2010
 */
    b = b && strcmp (buffer, "[[x^2 - y, u^2*y - u^2 + u*x - u - x + 1]]") == 0;

    return b ? 0 : 1;
}
