#include "bad.h"

/*
 * Variant of dae.c, raising an "out of time" error
 */

int main ()
{   struct bad_intersectof_regchain ideal;
    struct bap_tableof_polynom_mpz eqns, ineqns;
    struct bad_base_field K;
    struct bad_splitting_control C;
    bav_Iordering r;
    struct ba0_exception_code code;
    bool b;

/*
 * One second allocated for the computation
 */
    bad_restart (1, 0);
    BA0_PUSH_EXCEPTION (code);
    if (ba0_exception_is_raised (code))
    {	b = ba0_mesgerr == BA0_ERRALR;
#define PRINT 1
#undef PRINT
#if defined (PRINT)
	ba0_fprintf (stderr, "exception caught: %s\n", ba0_mesgerr);
#endif
	bad_terminate (ba0_init_level);
	return b ? 0 : 1;
    }

    ba0_sscanf2 ("ordering (derivations = [t], blocks = [s, y, c, x, z])",
		 "%ordering", &r);
    bav_R_push_ordering (r);
    bad_init_intersectof_regchain (&ideal);
    ba0_sscanf2 ("intersectof_regchain ([], \
	      	  [differential, primitive, autoreduced, normalized])", 
	     	  "%intersectof_regchain", &ideal);
    ba0_init_table ((ba0_table)&eqns);
    ba0_init_table ((ba0_table)&ineqns);
    ba0_sscanf2 ("[10*x[t] - 7*y - 10*s, 10*y[t] - 14*x - 10*c, \
		    10*s[t] - 25*z[t]*c, 10*c[t] + 25*z[t]*s, \
		    x^2 + y^2 - 1, c^2 + s^2 - 1]",
		 "%t[%Az]", &eqns);
    bad_init_base_field (&K);
    bad_init_splitting_control (&C);
    bad_Rosenfeld_Groebner (&ideal, &eqns, &ineqns, &K, &C);
    ba0_printf ("result = %intersectof_regchain_equations\n", &ideal);

    ba0_pull_exception (code);
    bad_terminate (ba0_init_level);
    return (0);
}
