#include "bad.h"

int main ()
{
    struct bad_preparation_equation E;
    bad_intersectof_regchain T;
    bap_tableof_polynom_mpz eqns;
    bad_regchain A;
    struct bap_polynom_mpz F;
    bap_polynom_mpz ddz;
    bav_Iordering r;
    struct ba0_mark M;
    ba0_mpz_t denom;
    char buffer [512];
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);

    bad_reduction_strategy = bad_gcd_prem_and_factor_reduction_strategy;

    ba0_sscanf2 ("ordering (derivations = [x,y], blocks = [[v,u]])",
		 "%ordering", &r);

    bav_R_push_ordering (r);
    eqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ba0_sscanf2 ("[u[x]^2 - 4*u, u[x,y]*v[y] - u + 1, v[x,x] - u[x]]",
    		 "%t[%Az]", eqns);

    T = bad_new_intersectof_regchain ();
    ba0_sscanf2 
	("intersectof_regchain ([], \
		[differential, squarefree, coherent, primitive, autoreduced])",
	 "%intersectof_regchain", T);

    bad_Rosenfeld_Groebner 
		(T, eqns, (bap_tableof_polynom_mpz)0, 
		 (bad_base_field)0, (bad_splitting_control)0);
/*
 * Computation checked in rg1.c
 */
    A = T->inter.tab [0];

    bap_init_polynom_mpz (&F);
    ba0_sscanf2 ("3*(u[x]^2-4*u)", "%Az", &F);
 
    bad_init_preparation_equation (&E);
    bad_set_preparation_equation_polynom 
				(&E, &F, (__mpz_struct*)0, A, 0, &ddz);
    bad_check_preparation_equation (&E);

    ba0_sprintf (buffer, "%preparation_equation", &E);
    b = strcmp (buffer, "1 * (3*u[x]^2 - 12*u) = (3)*z2") == 0;

    ba0_sscanf2 ("u[x,y]*v[y] - u + 1", "%Az", &F);
    mpz_init_set_si (denom, 7);

    bad_init_preparation_equation (&E);
    bad_set_preparation_equation_polynom (&E, &F, denom, A, 0, &ddz);
    bad_check_preparation_equation (&E);
/*
 * There are different reductions possible.
 */
    ba0_sprintf (buffer, "%preparation_equation", &E);
    b = b && 
	(strcmp (buffer, "(2*u[y])^2*(2*u[x]) * (1/7)*(u[x,y]*v[y] - u + 1) = (1/7)*(2*u[x]*u[y]*u - 2*u[x]*u[y])*z2[y] + (1/7)*(16*u)*z3 + (1/7)*(2*u[y])*z3*z2[y] + (1/7)*(8)*z1*z3") == 0 || 
	 strcmp (buffer, "(2*u[y])^3 * (1/7)*(u[x,y]*v[y] - u + 1) = (1/7)*(2*u[x]*u[y]*u - 2*u[x]*u[y])*z1[x] + (1/7)*(4*u[x]*u[y])*z3 + (1/7)*(4*u[y]*u - 4*u[y])*z2 + (1/7)*(-8*u[y]*u + 8*u[y])*z1 + (1/7)*(2*u[y])*z3*z1[x]") == 0);

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
