#include "bad.h"

int main ()
{
    bad_preparation_equation E;
    bad_intersectof_regchain T;
    bap_tableof_polynom_mpz eqns;
    bad_regchain A;
    bap_polynom_mpz F;
    bap_polynom_mpz ddz;
    bav_Iordering r;
    struct ba0_mark M;
    ba0_int_p i;
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);

    ba0_sscanf2 ("ordering (derivations = [t], blocks = [u])",
		 "%ordering", &r);
    bav_R_push_ordering (r);
    eqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    E = bad_new_preparation_equation ();
    T = bad_new_intersectof_regchain ();
/*
 * Decompose u'^2 - 4*u
 */
    ba0_sscanf2 ("[u[t]^2 - 4*u]", "%t[%Az]", eqns);
    F = eqns->tab [0];
    ba0_sscanf2 
	("intersectof_regchain ([], \
		[differential, squarefree, coherent, primitive, autoreduced])",
	 "%intersectof_regchain", T);
    bad_Rosenfeld_Groebner 
		(T, eqns, (bap_tableof_polynom_mpz)0, 
		 (bad_base_field)0, (bad_splitting_control)0);
/*
 * Remove the non essential components
 */
    i = 0;
    do
    {	A = T->inter.tab [i];
	if (A->decision_system.size > 1)
	    ba0_delete_table ((ba0_table)&T->inter, i);
	else
	{   bad_set_preparation_equation_polynom 
					(E, F, (__mpz_struct*)0, A, 0, &ddz);
	    if (! bad_low_power_theorem_condition_to_be_a_component (E))
		ba0_delete_table ((ba0_table)&T->inter, i);
	    else
		i += 1;
	}
    } while (i < T->inter.size);
    b = T->inter.size == 2;
/*
 * Decompose u'^2 - 4*u^3
 */
    ba0_sscanf2 ("[u[t]^2 - 4*u^3]", "%t[%Az]", eqns);
    F = eqns->tab [0];
    ba0_sscanf2 
	("intersectof_regchain ([], \
		[differential, squarefree, coherent, primitive, autoreduced])",
	 "%intersectof_regchain", T);
    bad_Rosenfeld_Groebner 
		(T, eqns, (bap_tableof_polynom_mpz)0, 
		 (bad_base_field)0, (bad_splitting_control)0);
/*
 * Remove the non essential components
 */
    i = 0;
    do
    {	A = T->inter.tab [i];
	if (A->decision_system.size > 1)
	    ba0_delete_table ((ba0_table)&T->inter, i);
	else
	{   bad_set_preparation_equation_polynom 
					(E, F, (__mpz_struct*)0, A, 0, &ddz);
	    if (! bad_low_power_theorem_condition_to_be_a_component (E))
		ba0_delete_table ((ba0_table)&T->inter, i);
	    else
		i += 1;
	}
    } while (i < T->inter.size);
    b = b && T->inter.size == 1;

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
