#include "bad.h"

int main ()
{
    struct bad_base_field K;
    bad_intersectof_regchain T;
    bap_tableof_polynom_mpz eqns;
    bav_Iordering r;
    struct ba0_mark M;
    char buffer [512];
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);
/*
 * This example produces splittings over some of the components.
 */
    ba0_sscanf2 ("ordering (derivations = [x], blocks = [y])",
		 "%ordering", &r);

    bav_R_push_ordering (r);
    eqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ba0_sscanf2 ("[-y[x,x]^2-2*y[x,x]*y[x]*y^3+4*y[x]^3*y^2]",
    		 "%t[%Az]", eqns);

    T = bad_new_intersectof_regchain ();
    ba0_sscanf2 
	("intersectof_regchain ([], \
		[differential, squarefree, coherent, primitive, autoreduced])",
	 "%intersectof_regchain", T);

    bad_init_base_field (&K);

    bad_Rosenfeld_Groebner 
	(T, eqns, (bap_tableof_polynom_mpz)0, &K, (bad_splitting_control)0);
    b = T->inter.size == 3;

    bad_low_power_theorem_simplify_intersectof_regchain (T, T, &K);

    ba0_sprintf (buffer, "%intersectof_regchain", T);
    b = strcmp (buffer, "intersectof_regchain ([regchain ([y[x,x]^2 + 2*y[x,x]*y[x]*y^3 - 4*y[x]^3*y^2], [differential, autoreduced, primitive, squarefree]), regchain ([4*y[x] + y^4], [differential, prime, autoreduced, primitive, squarefree])], [differential, autoreduced, primitive, squarefree])") == 0;

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
