#include "bad.h"

int main ()
{
    struct bad_base_field K;
    bad_intersectof_regchain T;
    bap_tableof_polynom_mpz eqns;
    bav_Iordering r;
    struct ba0_mark M;
    static char buffer [8192];
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);
/*
 * This example blows up if one is not careful with base field reductions
 */
    ba0_sscanf2 ("ordering (derivations = [x], blocks = [y,[a,b,c]])",
		 "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_sscanf2 ("[a, b, c]", "%t[%param]", &bav_parameters);

    bad_init_base_field (&K);
    bad_set_base_field_generators_and_relations 
				(&K, 0, 0, &bav_parameters, true, false);

    bav_set_settings_variable (&bav_scanf_diff_variable, 0, 0);

    eqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ba0_sscanf2 ("[-2*(x+a)^6*(y(x)+diff(y(x),x)*x)^3*b^3*c^2+a^3*c^2-27*x^4*y(x)^4*b^3*c^2-54*b^4*x^2*y(x)^2*c-27*b^5-3*a*(x+a)^4*(y(x)+diff(y(x),x)*x)^2*b^2*c^2]", "%t[%Az]", eqns);

    T = bad_new_intersectof_regchain ();
    ba0_sscanf2 
	("intersectof_regchain ([], \
		[differential, squarefree, coherent, primitive, autoreduced])",
	 "%intersectof_regchain", T);


    bad_Rosenfeld_Groebner 
	(T, eqns, (bap_tableof_polynom_mpz)0, &K, (bad_splitting_control)0);
    b = T->inter.size == 2;

    ba0_sprintf (buffer, "%intersectof_regchain_equations", T);

    bad_low_power_theorem_simplify_intersectof_regchain (T, T, &K);
    b = b && T->inter.size == 2;

    ba0_sprintf (buffer, "%intersectof_regchain_equations", T);

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
