#include "bad.h"

int main ()
{   struct bad_base_field K;
    struct bad_regchain A;
    struct bad_intersectof_regchain T;
    struct bap_tableof_polynom_mpz eqns, ineqns;
    bav_Iordering r;
    struct ba0_mark M;
    bool b;
    char buffer [1024];

    bad_restart (0, 0);
    ba0_record (&M);

    bad_reduction_strategy = bad_gcd_prem_and_factor_reduction_strategy;
    bav_set_settings_variable (&bav_scanf_diff_variable, 0, 0);

    ba0_sscanf2 ("ordering (derivations = [t], blocks = [[E, S, ES, P], [k[1], k[-1], k[2]]])", "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_sscanf2 ("[k[1], k[-1], k[2]]", "%t[%param]", &bav_parameters);

    bad_init_regchain (&A);
    ba0_sscanf2 ("regchain ([], [differential, squarefree, coherent, primitive, autoreduced, prime])", "%pretend_regchain", &A);
    bad_init_base_field (&K);
    bad_set_base_field_generators_and_relations 
	(&K, (bav_tableof_variable)0, &A, &bav_parameters, true, false);

    ba0_init_table ((ba0_table)&eqns);
    ba0_sscanf2 ("[diff(ES(t),t), diff(E(t),t)+k[1]*E(t)*S(t)-k[-1]*ES(t)-k[2]*ES(t), diff(S(t),t)+k[1]*E(t)*S(t)-k[-1]*ES(t), diff(ES(t),t)-k[1]*E(t)*S(t)+k[-1]*ES(t)+k[2]*ES(t), diff(P(t),t)-k[2]*ES(t)]", "%t[%Az]", &eqns);

    ba0_init_table ((ba0_table)&ineqns);
    ba0_sscanf2 ("[]", "%t[%Az]", &ineqns);

    bad_init_intersectof_regchain (&T);
    ba0_sscanf2
        ("intersectof_regchain ([], \
                [differential, squarefree, coherent, primitive, autoreduced])",
         "%intersectof_regchain", &T);

    bad_Rosenfeld_Groebner (&T, &eqns, &ineqns, &K, (bad_splitting_control)0);

    ba0_sprintf (buffer, "%intersectof_regchain_equations", &T);
    b = strcmp (buffer, "[[k[2][t], k[-1][t], k[1][t], ES, E, P[t], S[t]], [k[2][t], k[-1][t], k[1][t], ES, S, P[t], E[t]]]") == 0;

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
