#include "bad.h"

int main ()
{   bav_Iordering r;
    bad_regchain C;
    bap_ratfrac_mpz NF;
    bap_polynom_mpz A;
    struct ba0_mark M;
    char buffer [512];
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);

    ba0_sscanf2 ("ordering (derivations = [x,y], blocks = [[v, u]])",
		 "%ordering", &r);

    bav_R_push_ordering (r);

    C = bad_new_regchain ();
    ba0_sscanf2 ("regchain ([v[x,x]-u[x], 4*v[y]*u+u[x]*u[y]-u[x]*u[y]*u, \
			     u[x]^2-4*u, u[y]^2-2*u], \
			    [differential, prime, autoreduced, \
			     primitive])",
		 "%pretend_regchain", C);
    A = bap_new_polynom_mpz ();
    ba0_sscanf2 ("u[x,x]", "%Az", A);
    NF = bap_new_ratfrac_mpz ();
    bad_normal_form_polynom_mod_regchain (NF, A, C, (bap_polynom_mpz*)0);
    ba0_sprintf (buffer, "%Qz", NF);
    b = strcmp (buffer, "2") == 0;
    if (! b) goto fin;

    ba0_sscanf2 ("u[x,y]", "%Az", A);
    bad_normal_form_polynom_mod_regchain (NF, A, C, (bap_polynom_mpz*)0);
    ba0_sprintf (buffer, "%Qz", NF);
    b = strcmp (buffer, "(u[x]*u[y])/(2*u)") == 0;
fin:
    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}

