#include "bad.h"

int main ()
{
    struct bad_base_field K;
    bav_Iordering r;
    bap_tableof_polynom_mpz eqns, ineqns;
    bad_splitting_control C;
    bad_intersectof_regchain T;
    bap_ratfrac_mpz NF;
    bap_polynom_mpz A;
    struct ba0_mark M;
    char buffer [512];
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);

    ba0_sscanf2 ("ordering (derivations = [x,y], blocks = [[u,v]])",
		 "%ordering", &r);
    bav_R_push_ordering (r);

    eqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ineqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ba0_sscanf2 ("[u[x]^2-4*u, u[x,y]*v[y]-u+1, v[x,x]-u[x]]", "%t[%Az]", eqns);

    T = bad_new_intersectof_regchain ();
    ba0_sscanf2
	("intersectof_regchain ([], [differential, autoreduced, primitive, squarefree, coherent, normalized])",
	 "%intersectof_regchain", T);

    bad_init_base_field (&K);

    C = bad_new_splitting_control ();

    bad_Rosenfeld_Groebner (T, eqns, ineqns, &K, C);

    ba0_sprintf (buffer, "%intersectof_regchain_equations", T);
    b = strcmp (buffer, "[[2*v[y]^2 - u^2 + 2*u - 1, u[y]^2 - 2*u, u[x]*u - u[x] - 2*u[y]*v[y], v[x,x]*u - v[x,x] - 2*u[y]*v[y]]]") == 0;

    A = bap_new_polynom_mpz ();
    ba0_sscanf2 ("v[x,x,y]", "%Az", A);
    NF = bap_new_ratfrac_mpz ();
    bad_normal_form_polynom_mod_regchain 
			(NF, A, T->inter.tab [0], (bap_polynom_mpz*)0);

    ba0_sprintf (buffer, "%Qz", NF);
    b = b && strcmp (buffer, "(2*v[y])/(u - 1)") == 0;

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
