#include "bad.h"

int main ()
{   bav_Iordering r, rbar;
    bad_regchain C, Cbar;
    ba0_tableof_string D;
    struct ba0_mark M;
    char buffer [1024];
    char ref_buff [1024];
    bool ok;

    bad_restart (0, 0);
    ba0_record (&M);

    ba0_sscanf2 
	("ordering (derivations = [t], blocks = [[x1,x2],[ke,k12,k21]])",
	 "%ordering", &r);
    ba0_sscanf2 
	("ordering (derivations = [t], blocks = [x2,[k12,k21,ke],x1])",
	 "%ordering", &rbar);

    bav_R_push_ordering (r);

    C = bad_new_regchain ();
    ba0_sscanf2 
	("regchain (\
		[x1[t] + (ke + k12)*x1 - k21*x2, \
		 x2[t] - k12*x1 + k21*x2, \
		 ke[t], k12[t], k21[t]], \
		[differential, prime, primitive, coherent, squarefree])",
	 "%regchain", C);

    Cbar = bad_new_regchain ();
    D = (ba0_tableof_string)ba0_new_table ();
    ba0_sscanf2 ("[autoreduced, primitive, normalized]", "%t[%s]", D);
    bad_set_desired_properties_regchain (Cbar, D);

    bad_pardi (Cbar, rbar, C);

    ba0_garbage ("%regchain", &M, &Cbar);
    
    ba0_sprintf (buffer, "%regchain", Cbar);

    sprintf (ref_buff, "%s%s",
	"regchain ([x1[t,t,t,t]*x1[t,t]*x1 - x1[t,t,t,t]*x1[t]^2 - x1[t,t,t]^2*x1 + 2*x1[t,t,t]*x1[t,t]*x1[t] - x1[t,t]^3, k21*ke*x1[t,t]*x1 - k21*ke*x1[t]^2 - x1[t,t,t]*x1[t] + x1[t,t]^2, k12*ke*x1[t,t]*x1 - k12*ke*x1[t]^2 + ke^2*x1[t,t]*x1 - ke^2*x1[t]^2 + ke*x1[t,t,t]*x1 - ke*x1[t,t]*x1[t]", 
        " + x1[t,t,t]*x1[t] - x1[t,t]^2, ke[t], x2*x1[t,t,t]*x1[t] - x2*x1[t,t]^2 + ke*x1[t,t,t]*x1^2 - 2*ke*x1[t,t]*x1[t]*x1 + ke*x1[t]^3 + x1[t,t,t]*x1[t]*x1 - x1[t,t]^2*x1], [differential, prime, autoreduced, primitive, squarefree, coherent, normalized])");
    ok = strcmp (buffer, ref_buff) == 0;
/*
    ba0_printf ("%regchain\n", Cbar);
*/

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return ok ? 0 : 1;
}

