#include "bad.h"

int main ()
{   bav_Iordering r;
    bad_regchain C;
    bap_ratfrac_mpz NF;
    bap_polynom_mpz A;
    bav_variable u;
    struct ba0_mark M;
    char buffer [512];
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);

    ba0_sscanf2 ("ordering (derivations = [x,y], blocks = [w, [v, u], t])",
		 "%ordering", &r);
    ba0_sscanf2 ("u", "%v", &u);

    bav_R_push_ordering (r);

    C = bad_new_regchain ();
    ba0_sscanf2 ("regchain ([v[x,x]-u[x], 4*v[y]*u+u[x]*u[y]-u[x]*u[y]*u, \
			     u[x]^2-4*u, u[y]^2-2*u], \
			    [differential, prime, autoreduced, \
			     primitive])",
		 "%pretend_regchain", C);
    A = bap_new_polynom_mpz ();
    ba0_sscanf2 ("u[x,x]", "%Az", A);
    NF = bap_new_ratfrac_mpz ();
    bad_reduced_form_polynom_mod_regchain (NF, A, u, C);
    ba0_sprintf (buffer, "%Qz", NF);
    b = strcmp (buffer, "2") == 0;

    ba0_sscanf2 ("u[x,y]", "%Az", A);
    bad_reduced_form_polynom_mod_regchain (NF, A, u, C);
    ba0_sprintf (buffer, "%Qz", NF);
    b = b && strcmp (buffer, "u[x,y]") == 0;

    ba0_sscanf2 ("4*u*v[y]", "%Az", A);
    bad_reduced_form_polynom_mod_regchain (NF, A, u, C);
    ba0_sprintf (buffer, "%Qz", NF);
    b = b && strcmp (buffer, "u[x]*u[y]*u - u[x]*u[y]") == 0;

    ba0_sscanf2 ("(w+1)*(u*v[y])+ u[x,y]*t", "%Az", A);
    bad_reduced_form_polynom_mod_regchain (NF, A, u, C);
    ba0_sprintf (buffer, "%Qz", NF);
    b = b && strcmp (buffer, "(w*u[x]*u[y]*u - w*u[x]*u[y] + 4*u[x,y]*t + u[x]*u[y]*u - u[x]*u[y])/(4)") == 0;

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}

