#include "bad.h"

int main ()
{
    bav_Iordering r;
    bap_tableof_polynom_mpz eqns;
    bad_intersectof_regchain T;
    struct ba0_mark M;
    char buffer [512];
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);

    bad_reduction_strategy = bad_gcd_prem_and_factor_reduction_strategy;

    ba0_sscanf2 ("ordering (derivations = [x,y], blocks = [[v,u]])",
		 "%ordering", &r);

    bav_R_push_ordering (r);
    eqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ba0_sscanf2 ("[u[x]^2 - 4*u, u[x,y]*v[y] - u + 1, v[x,x] - u[x]]",
    		 "%t[%Az]", eqns);

    T = bad_new_intersectof_regchain ();
    ba0_sscanf2 
	("intersectof_regchain ([], \
		[differential, squarefree, coherent, primitive, autoreduced])",
	 "%intersectof_regchain", T);

    bad_Rosenfeld_Groebner 
	(T, eqns, (bap_tableof_polynom_mpz)0, 
	 (bad_base_field)0, (bad_splitting_control)0);

    ba0_sprintf (buffer, "%intersectof_regchain", T);
    b = strcmp (buffer, "intersectof_regchain ([regchain (\
[u[y]^2 - 2*u, u[x]^2 - 4*u, 2*v[y]*u[y] - u[x]*u + u[x], v[x,x] - u[x]], \
[differential, autoreduced, primitive, squarefree, coherent])], \
[differential, autoreduced, primitive, squarefree, coherent])") == 0;

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
