#include "bad.h"

int main ()
{
    struct bad_base_field K;
    bav_Iordering r;
    bap_tableof_polynom_mpz eqns, ineqns;
    bad_splitting_control C;
    bad_intersectof_regchain T;
    struct ba0_mark M;
    char buffer [512];
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);

    ba0_sscanf2 ("ordering (derivations = [x,y], blocks = [[v,u]])",
		 "%ordering", &r);
    bav_R_push_ordering (r);

    eqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ineqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ba0_sscanf2 ("[u[x]*x - u, 3*v[y]^2 - 1]", "%t[%Az]", eqns);

    T = bad_new_intersectof_regchain ();
    ba0_sscanf2
	("intersectof_regchain ([], [differential, autoreduced, primitive, squarefree, coherent, normalized])",
	 "%intersectof_regchain", T);

    bad_init_base_field (&K);

    C = bad_new_splitting_control ();

    bad_Rosenfeld_Groebner (T, eqns, ineqns, &K, C);

    ba0_sprintf (buffer, "%intersectof_regchain_equations", T);

    b = strcmp (buffer, "[[u[x]*x - u, 3*v[y]^2 - 1]]") == 0;

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
