#include "bad.h"

int main ()
{   struct bad_intersectof_regchain ideal;
    struct bad_splitting_control control;
    struct bad_base_field K;
    struct bap_tableof_polynom_mpz nulles, eqns, ineqs;
    struct bav_tableof_variable params;
    bav_Iordering r;
    bool b;
    static char buffer [4096];

    bad_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [x], blocks = [[_F2, _F1, y], N])", "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_init_table ((ba0_table)&params);
    ba0_sscanf2 ("[N]", "%t[%v]", &params);
    ba0_scanf_printf ("%t[%param]", "%t[%v]", &bav_parameters, &params);

    bav_set_settings_variable 
		(&bav_scanf_diff_variable, &bav_printf_diff_variable, 0);

    ba0_init_table ((ba0_table)&nulles);
    bap_zero_derivatives_of_tableof_parameter_mpz (&nulles, &bav_parameters);
    ba0_init_table ((ba0_table)&eqns);
    ba0_sscanf2 ("[_F2(x)^2-_F1(x), diff(_F1(x),x)*x-_F1(x)*N, -y(x)+y(x)*_F2(x)^2+1-_F2(x)]", "%t[%Az]", &eqns);
    ba0_concat_table ((ba0_table)&eqns, (ba0_table)&eqns, (ba0_table)&nulles);

    ba0_init_table ((ba0_table)&ineqs);
    ba0_sscanf2 ("[_F1(x), _F2(x), diff(_F1(x),x), (_F2(x)-1)*(_F2(x)+1)]", "%t[%Az]", &ineqs);

    bad_init_base_field (&K);
    bad_init_splitting_control (&control);

    bad_init_intersectof_regchain (&ideal);
    ba0_sscanf2 ("intersectof_regchain ([], [differential, normalized])",
		 "%intersectof_regchain", &ideal);
    bad_Rosenfeld_Groebner (&ideal, &eqns, &ineqs, &K, &control);

    ba0_sprintf (buffer, "%intersectof_regchain_equations", &ideal);

    b = strcmp ("[[diff (N, x), _F1(x)*y(x)^2 - y(x)^2 + 2*y(x) - 1, _F2(x)*y(x) + y(x) - 1, 2*diff (y(x), x)*x - y(x)^2*N + y(x)*N]]", buffer) == 0;
    return b ? 0 : 1;
}

