#include "bad.h"

/*
 * Trapped a serious bug in the gcd
 */

int main ()
{   struct bad_intersectof_regchain ideal;
    struct bad_splitting_control control;
    struct bad_base_field K;
    struct bad_regchain relations;
    struct bap_tableof_polynom_mpz eqns, ineqs;
    struct bav_tableof_variable params, generators, X;
    bav_Iordering r;
    struct ba0_tableof_string properties;
    bool b;
    static char buffer [4096];

    bad_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [x,y], blocks = [[u,v], w])", "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_init_table ((ba0_table)&params);
    ba0_sscanf2 ("[]", "%t[%v]", &params);
    ba0_scanf_printf ("%t[%param]", "%t[%v]", &bav_parameters, &params);

    bav_set_settings_variable 
		(&bav_scanf_diff_variable, &bav_printf_diff_variable, 0);

    ba0_init_table ((ba0_table)&eqns);
    ba0_sscanf2 ("[]", "%t[%Az]", &eqns);

    ba0_init_table ((ba0_table)&properties);
    ba0_sscanf2 ("[differential, normalized]", "%t[%s]", &properties);

    bad_init_regchain (&relations);
    bad_set_and_extend_regchain_tableof_polynom_mpz 
			(&relations, &eqns, 0, &properties, false, false);

    ba0_init_table ((ba0_table)&generators);
    ba0_sscanf2 ("[]", "%t[%v]", &generators);

    bad_init_base_field (&K);
    bad_set_base_field_generators_and_relations
	(&K, &generators, &relations, &bav_parameters, false, false);

    ba0_sprintf (buffer, "%base_field", &K);

    ba0_init_table ((ba0_table)&X);
    bad_base_field_implicit_generators (&X, &K, &generators, &relations);
    ba0_sprintf (buffer, "%t[%v]", &X);
    b = strcmp (buffer, "[]") == 0;

    ba0_sscanf2 ("[diff(u(x,y),x,y), diff(u(x,y),y,y)^2-1, diff(u(x,y),x,x)^2*v(x,y)*w(x,y)+diff(u(x,y),x,x)*v(x,y)+diff(u(x,y),x), diff(w(x,y),x)-w(x,y), diff(w(x,y),y)-w(x,y)]", "%t[%Az]", &eqns);

    ba0_init_table ((ba0_table)&ineqs);
    ba0_sscanf2 ("[w(x,y)]", "%t[%Az]", &ineqs);

    bad_init_splitting_control (&control);
    bad_init_intersectof_regchain (&ideal);
    ba0_sscanf2 ("intersectof_regchain ([], [differential, normalized])",
		 "%intersectof_regchain", &ideal);
    bad_Rosenfeld_Groebner (&ideal, &eqns, &ineqs, &K, &control);
    bad_remove_redundant_components_intersectof_regchain (&ideal, &ideal);

    ba0_sprintf (buffer, "%intersectof_regchain_equations", &ideal);

    b = b && ideal.inter.size == 2;
    return b ? 0 : 1;
}

