#include "bad.h"

int main ()
{
    bav_Iordering r;
    bap_tableof_polynom_mpz eqns;
    bad_intersectof_regchain T;
    struct ba0_mark M;
    ba0_int_p i, n;
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);

/*
 * The RegularChains zerodim/l-3.tst test.
 * The ideal is radical, zero-dimensional. It has exactly 81 solutions.
 */
    ba0_sscanf2 ("ordering (derivations = [], blocks = [x,y,z,t])", "%ordering", &r);
    bav_R_push_ordering (r);

    eqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ba0_sscanf2 ("[x+y+z+t^3-1, x+y+z^3+t-1, x+y^3+z+t-1, x^3+y+z+t-1]", "%t[%Az]", eqns);

    T = bad_new_intersectof_regchain ();
    ba0_sscanf2
	("intersectof_regchain ([], [autoreduced, primitive])",
	 "%intersectof_regchain", T);

    bad_Rosenfeld_Groebner 
		(T, eqns, (bap_tableof_polynom_mpz)0, 
		 (bad_base_field)0, (bad_splitting_control)0);

    bad_remove_redundant_components_intersectof_regchain (T, T);

    n = 0;
    for (i = 0; i < T->inter.size; i++)
	n += bad_product_of_leading_degrees_regchain (T->inter.tab [i]);

    b = n == 81;

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
