#include "bad.h"

int main ()
{
    bav_Iordering r;
    bap_tableof_polynom_mpz eqns, ineqns;
    bad_intersectof_regchain T;
    struct ba0_exception_code code;
    struct ba0_mark M;
    bool b;

    bad_restart (10, 0);
/*
 * Timeout is expected
 */
    BA0_PUSH_EXCEPTION (code);
    if (ba0_exception_is_raised (code))
    {	if (ba0_mesgerr == BA0_ERRALR)
	    return 0;
	BA0_RAISE_EXCEPTION (ba0_mesgerr);
    }

    ba0_record (&M);
/*
 * test("posdim/Hoffmann.tst");
 */
    ba0_sscanf2 ("ordering (derivations = [], blocks = [x11,x10,x9,x8,x7,x6,x5,x4,x3,x2,x1,x0,d15,d14,d13,d12,d11,d10,d9,d8,d7,d6,d5,d4,d3,d2,d1,d0])", 
			"%ordering", &r);
    bav_R_push_ordering (r);

    eqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ineqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ba0_sscanf2 ("[x2^2+x3^2-d2^2, x5^2+x6^2-d3^2, x8^2+x9^2-d4^2, x0^2-2*x0*x3+x1^2+x3^2-d6^2, x0^2-2*x0*x6+x4^2+x6^2-d7^2, x0^2-2*x0*x9+x7^2+x9^2-d8^2, x1^2-2*x1*x10+x2^2-2*x2*x11+x10^2+x11^2-d12^2, x4^2-2*x4*x10+x5^2-2*x5*x11+x10^2+x11^2-d14^2, x7^2-2*x7*x10+x8^2-2*x8*x11+x10^2+x11^2-d15^2, x1^2-2*x1*x4-2*x2*x5-2*x3*x6+x4^2+d2^2+d3^2-d10^2, x1^2-2*x1*x7-2*x2*x8-2*x3*x9+x7^2+d2^2+d4^2-d11^2, x4^2-2*x4*x7-2*x5*x8-2*x6*x9+x7^2+d3^2+d4^2-d13^2]", "%t[%Az]", eqns);
    ba0_sscanf2 ("[]", "%t[%Az]", ineqns);

    T = bad_new_intersectof_regchain ();
    ba0_sscanf2
	("intersectof_regchain ([], [primitive])",
	 "%intersectof_regchain", T);

    bad_Rosenfeld_Groebner 
	(T, eqns, ineqns, (bad_base_field)0, (bad_splitting_control)0);

    ba0_printf ("%intersectof_regchain, number of components = %d\n", 
			T, T->inter.size);

    b = false;
    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
