#include "bad.h"

int main ()
{
    bav_Iordering r, rbar;
    bap_tableof_polynom_mpz eqns, ineqns;
    bav_tableof_variable alg_indep;
    bad_intersectof_regchain T;
    bad_regchain C;
    struct ba0_mark M;
    char buffer [512];
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);

    bad_reduction_strategy = bad_gcd_prem_and_factor_reduction_strategy;

    ba0_sscanf2 ("ordering (derivations = [t,x,y], blocks = [degrevlexB[p,v1,v2]])", "%ordering", &r);

    bav_R_push_ordering (r);
    T = bad_new_intersectof_regchain ();
    ba0_sscanf2 ("intersectof_regchain ([], [differential, squarefree, coherent, primitive, autoreduced])", "%intersectof_regchain", T);
    eqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ineqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    alg_indep = (bav_tableof_variable)ba0_new_table ();
    ba0_sscanf2 ("[v1[t] + v1*v1[x] + v2*v1[y] + p[x], v2[t] + v1*v2[x] + v2*v2[y] + p[y], v1[x] + v2[y]]", "%t[%Az]", eqns);

    bad_Rosenfeld_Groebner 
	(T, eqns, ineqns, (bad_base_field)0, (bad_splitting_control)0);

    C = T->inter.tab [0];

    ba0_garbage ("%regchain", &M, &C);

    bad_set_structural_property_attchain 
	    		(&C->attrib, bad_prime_structural_property);

    ba0_sprintf (buffer, "%regchain", C);

    ba0_sscanf2 ("ordering (derivations = [x,y,t], blocks = [[p,v1],v2])", "%ordering", &rbar);

    b = strcmp (buffer, "regchain ([v1[x] + v2[y], v2[t] + v2[x]*v1 + p[y] + v2[y]*v2, v1[t] + p[x] + v1[y]*v2 - v2[y]*v1, p[x,x] + p[y,y] + 2*v2[x]*v1[y] + 2*v2[y]^2], [differential, prime, autoreduced, primitive, squarefree, coherent])") == 0;

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
