#include "bad.h"

int main ()
{   struct bad_base_field K;
    bav_Iordering r;
    bap_tableof_polynom_mpz eqns;
    bav_tableof_variable nonzero;
    bad_intersectof_regchain T;
    struct ba0_mark M;
    static char buffer [256];
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);

    ba0_sscanf2 ("ordering (derivations = [x], blocks = [u, v])",
		 "%ordering", &r);
    bav_R_push_ordering (r);

    eqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ba0_sscanf2 ("[u + v[x] + v, v[x]]", "%t[%Az]", eqns);

    nonzero = (bav_tableof_variable)ba0_new_table ();
    ba0_sscanf2 ("[u, v]", "%t[%v]", nonzero);

    T = bad_new_intersectof_regchain ();
    ba0_sscanf2
	("intersectof_regchain ([], [primitive, autoreduced, normalized])",
	 "%intersectof_regchain", T);

    bad_init_base_field (&K);
    bad_set_base_field_generators_and_relations 
	(&K, nonzero, (bad_regchain)0, (bav_tableof_parameter)0, true, false);

    ba0_sprintf (buffer, "%base_field", &K);
    b = strcmp (buffer, "field (differential = true, generators = [u, v])") == 0;

    ba0_sscanf2 (buffer, "%base_field", &K);

    bad_Rosenfeld_Groebner 
	(T, eqns, (bap_tableof_polynom_mpz)0, &K, (bad_splitting_control)0);

    b = b && T->inter.size == 0;

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
