#ifndef BAP_CLOT_COMMON_H
#define BAP_CLOT_COMMON_H 1

#include "bap_common.h"
#include "bap_termanager.h"

BEGIN_C_DECLS

enum bap_typeof_monom_sequence 
	{ bap_increasing_monom_sequence, bap_decreasing_monom_sequence,
          bap_random_monom_sequence };

struct bap_clot_parameters {
    enum bap_typeof_termanager type;
    enum bap_typeof_monom_sequence sens;
};

#define BAP_SIZE_CLOT_PARAMETERS_STACK   10
#define bap_clot_parameters_sp		bap_global.clot_common.sp

extern BAP_DLL void bap_reset_clot_parameters_stack (void);
extern BAP_DLL void bap_push_clot_parameters_stack
		(enum bap_typeof_termanager, enum bap_typeof_monom_sequence);
extern BAP_DLL void bap_pull_clot_parameters_stack (void);
extern BAP_DLL enum bap_typeof_termanager bap_current_typeof_termanager (void);
extern BAP_DLL enum bap_typeof_monom_sequence 
		bap_current_typeof_monom_sequence (void);

END_C_DECLS

#endif /* !BAP_CLOT_COMMON_H */
