#ifndef BAP_INDEXED_ACCESS_H
#define BAP_INDEXED_ACCESS_H 1

#include "bap_common.h"

BEGIN_C_DECLS

typedef struct bap_indexed_access {
    ba0_int_p alloc;
    ba0_int_p size;
    struct ba0_tableof_tableof_int_p tab_index;
} *bap_indexed_access;

extern BAP_DLL void bap_init_indexed_access (bap_indexed_access);
extern BAP_DLL void bap_realloc_indexed_access (bap_indexed_access, ba0_int_p);
extern BAP_DLL void bap_reverse_indexed_access (bap_indexed_access);

extern BAP_DLL ba0_garbage1_function bap_garbage1_indexed_access;
extern BAP_DLL ba0_garbage2_function bap_garbage2_indexed_access;

END_C_DECLS

#endif /* !BAP_INDEXED_ACCESS_H */
