#ifndef BAP_POLYSPEC_MPZM_H
#define BAP_POLYSPEC_MPZM_H 1

#include "bap_common.h"
#include "bap_polynom_mpz.h"
#include "bap_polynom_mpzm.h"
#include "bap_polynom_mpq.h"
#include "bap_polynom_mint_hp.h"
#include "bap_product_mpz.h"
#include "bap_product_mpzm.h"

BEGIN_C_DECLS

extern BAP_DLL void bap_polynom_mpq_to_mpzm 
				(bap_polynom_mpzm, bap_polynom_mpq);
extern BAP_DLL void bap_polynom_mpz_to_mpzm 
				(bap_polynom_mpzm, bap_polynom_mpz);
extern BAP_DLL void bap_polynom_mint_hp_to_mpzm 
				(bap_polynom_mpzm, bap_polynom_mint_hp);
extern BAP_DLL void bap_mods_polynom_mpzm (bap_polynom_mpz, bap_polynom_mpzm);
extern BAP_DLL void bap_mods_product_mpzm (bap_product_mpz, bap_product_mpzm);

extern BAP_DLL void bap_Bezout_polynom_mpzm 
		(bap_polynom_mpzm, bap_polynom_mpzm, bap_polynom_mpzm, 
		 bap_polynom_mpzm, bap_polynom_mpzm, ba0_mpz_t, bav_Idegree);
extern BAP_DLL void bap_coeftayl_polynom_mpzm 
	(bap_polynom_mpzm, bap_polynom_mpzm, struct bav_ev_value, bav_Idegree);
extern BAP_DLL void bap_quorem_polynom_mpzm 
	(bap_polynom_mpzm, bap_polynom_mpzm, bav_rank, 
	 bap_polynom_mpzm, bap_polynom_mpzm);
extern BAP_DLL void bap_uni_Diophante_polynom_mpzm 
	(struct bap_polynom_mpzm*, bap_product_mpzm, bav_rank, ba0_mpz_t, 
	 bav_Idegree);
extern BAP_DLL void bap_multi_Diophante_polynom_mpzm
	(struct bap_polynom_mpzm*, bap_product_mpzm, bap_polynom_mpzm, 
	 bav_ev_point, bav_Idegree, ba0_mpz_t, bav_Idegree);

END_C_DECLS

#endif /* !BAP_POLYSPEC_MPZM_H */
