#ifndef BAP_SELECTION_H
#define BAP_SELECTION_H 1

#include "bap_common.h"

BEGIN_C_DECLS

#define BAP_SIZE_SELECTION      4

typedef struct bap_selection {
    ba0_int_p i;
    struct _tab {
        bav_Iordering ordering;
        bav_variable varmax;
    } tab [BAP_SIZE_SELECTION];
} *bap_selection;

extern BAP_DLL void bap_init_selection 
				(bap_selection, bav_variable, bav_Iordering);
extern BAP_DLL void bap_set_selection (bap_selection, bap_selection);
extern BAP_DLL bav_Iordering bap_ordering_selection (bap_selection);
extern BAP_DLL bav_variable bap_variable_selection (bap_selection);
extern BAP_DLL void bap_change_ordering_selection 
				(bap_selection, bav_Iordering);
extern BAP_DLL void bap_change_variable_selection 
				(bap_selection, bav_variable);
extern BAP_DLL void bap_push_selection 
				(bap_selection, bav_variable, bav_Iordering);
extern BAP_DLL void bap_pull_selection (bap_selection);
extern BAP_DLL bool bap_identity_selection (bap_selection, bav_Iordering);
extern BAP_DLL void bap_term_selection 
				(bav_term, bav_Iordering, bap_selection);
extern BAP_DLL void bap_switch_ring_selection 
				(bap_selection, bav_differential_ring);

END_C_DECLS

#endif /* !BAP_SELECTION_H */
