#include "bap.h"

int main ()
{   bav_Iordering r;
    struct bap_polynom_mpz A;
    struct bap_product_mpz P;
    char buffer [512];
    bool b;

    bap_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [], blocks = [x,y])", "%ordering", &r);
    bav_R_push_ordering (r);
    bap_init_polynom_mpz (&A);
    bap_init_product_mpz (&P);

    ba0_sscanf2 ("12345*y^3 - 3357968*y^2 + 34890*y - 20128", "%Az", &A);
    bap_factor_polynom_mpz (&P, &A);
    ba0_sprintf (buffer, "%Pz", &P);
    b = strcmp ("(12345*y^2 - 128*y + 74)*(y - 272)", buffer) == 0 ||
	strcmp ("(y - 272)*(12345*y^2 - 128*y + 74)", buffer) == 0;

    ba0_sscanf2 ("(x^7*y + 12345*y^2 - 37*x)*(x*y - 17*x^5)^2", "%Az", &A);
    bap_factor_polynom_mpz (&P, &A);
    ba0_sprintf (buffer, "%Pz", &P);
    b = b && 
	(strcmp 
	    ("x^2*(x^7*y - 37*x + 12345*y^2)*(17*x^4 - y)^2", buffer) == 0 || 
	 strcmp 
	    ("x^2*(17*x^4 - y)^2*(x^7*y - 37*x + 12345*y^2)", buffer) == 0);

    ba0_sscanf2 ("(x^7*y + 12345*y^2 - 37*x)*(x*y - 17*x^5)", "%Az", &A);
    bap_factor_polynom_mpz (&P, &A);
    ba0_sprintf (buffer, "%Pz", &P);
    b = b && 
	(strcmp ("- x*(17*x^4 - y)*(x^7*y - 37*x + 12345*y^2)", buffer) == 0 ||
	 strcmp ("- x*(x^7*y - 37*x + 12345*y^2)*(17*x^4 - y)", buffer) == 0);

    bap_terminate (ba0_init_level);
    return b ? 0 : 1;
}

