#include "bap.h"

int main ()
{   bav_Iordering r;
    struct bap_polynom_mpz A;
    struct bap_polynom_mpz B;
    struct bap_polynom_mpz G;
    struct bap_polynom_mpz cofA;
    struct bap_polynom_mpz cofB;
    bool b;

    bap_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [], blocks = [a,x,c,y,b])", "%ordering", &r);
    bav_R_push_ordering (r);
    bap_init_polynom_mpz (&A);
    bap_init_polynom_mpz (&B);
    bap_init_polynom_mpz (&cofA);
    bap_init_polynom_mpz (&cofB);
    bap_init_polynom_mpz (&G);
    ba0_sscanf2 ("-2*a^6*b^3*c^2*x^3 - 12*a^5*b^3*c^2*x^4 - 30*a^4*b^3*c^2*x^5 - 40*a^3*b^3*c^2*x^6 - 30*a^2*b^3*c^2*x^7 - 12*a*b^3*c^2*x^8 - 2*b^3*c^2*x^9", "%Az", &A);
    ba0_sscanf2 ("-6*y*a^6*b^3*c^2*x^2 - 36*y*a^5*b^3*c^2*x^3 - 90*y*a^4*b^3*c^2*x^4 - 120*y*a^3*b^3*c^2*x^5 - 90*y*a^2*b^3*c^2*x^6 - 36*y*a*b^3*c^2*x^7 - 6*y*b^3*c^2*x^8 - 3*a^5*b^2*c^2*x^2 - 12*a^4*b^2*c^2*x^3 - 18*a^3*b^2*c^2*x^4 - 12*a^2*b^2*c^2*x^5 - 3*a*b^2*c^2*x^6", "%Az", &B);

    bap_gcd_polynom_mpz (&G, &cofA, &cofB, &A, &B);
    bap_mul_polynom_mpz (&cofA, &cofA, &G);
    bap_sub_polynom_mpz (&cofA, &cofA, &A);
    b = bap_is_zero_polynom_mpz (&cofA);
    bap_mul_polynom_mpz (&cofB, &cofB, &G);
    bap_sub_polynom_mpz (&cofB, &cofB, &B);
    b = b && bap_is_zero_polynom_mpz (&cofB);
    bap_terminate (ba0_init_level);
    return b ? 0 : 1;
}

