#include "bap.h"

int main ()
{   bav_Iordering r;
    struct bap_polynom_mpz A;
    struct bap_polynom_mpz B;
    struct bap_polynom_mpz G;
    struct bap_polynom_mpz cofA;
    struct bap_polynom_mpz cofB;
    bool b;

    bap_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [], blocks = [t,z,u,v])", "%ordering", &r);
    bav_R_push_ordering (r);
    bap_init_polynom_mpz (&A);
    bap_init_polynom_mpz (&B);
    bap_init_polynom_mpz (&cofA);
    bap_init_polynom_mpz (&cofB);
    bap_init_polynom_mpz (&G);
    ba0_sscanf2 ("65340*t^2*z^3 - 4840*t^2*z*u^2*v + 1320*t^2*z*u*v^2 - 718740*t*z^2*v^3 + 242*t*z*u^2*v^2 - 132*t*z*u*v^3 + 18*t*z*v^4 + 26620*t*u^2*v^4 - 7260*t*u*v^5 + 1976535*z*v^6 - 1331*u^2*v^5 + 726*u*v^6 - 99*v^7", "%Az", &A);
    ba0_sscanf2 ("97*z^2 - 22*u^2*v + 6*u*v^2", "%Az", &B);

    bap_gcd_polynom_mpz (&G, &cofA, &cofB, &A, &B);
    bap_mul_polynom_mpz (&cofA, &cofA, &G);
    bap_sub_polynom_mpz (&cofA, &cofA, &A);
    b = bap_is_zero_polynom_mpz (&cofA);
    bap_mul_polynom_mpz (&cofB, &cofB, &G);
    bap_sub_polynom_mpz (&cofB, &cofB, &B);
    b = b && bap_is_zero_polynom_mpz (&cofB);
    bap_terminate (ba0_init_level);
    return b ? 0 : 1;
}

