#include "bap.h"

int main ()
{   bav_Iordering r;
    struct bap_polynom_mpz A;
    struct bap_polynom_mpz B;
    struct bap_polynom_mpz G;
    struct bap_polynom_mpz cofA;
    struct bap_polynom_mpz cofB;
    bool b;

    bap_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [], blocks = [y,z,t])", "%ordering", &r);
    bav_R_push_ordering (r);
    bap_init_polynom_mpz (&A);
    bap_init_polynom_mpz (&B);
    bap_init_polynom_mpz (&cofA);
    bap_init_polynom_mpz (&cofB);
    bap_init_polynom_mpz (&G);
    ba0_sscanf2 ("440*y^5*t^2 + 660*y^4*z*t^2 + 9576*y^4*t - 384*y^4 - 660*y^3*z^2*t^2 + 23940*y^3*z*t + 768*y^3*z + 51678*y^3 - 2024*y^2*z^3*t^2 + 16704*y^2*z^2*t - 960*y^2*z^2 + 180873*y^2*z + 1188*y*z^4*t^2 - 43740*y*z^3*t + 576*y*z^3 + 317115*y*z^2 + 396*z^5*t^2 - 6480*z^4*t - 216*z^4 + 21141*z^3", "%Az", &A);
    ba0_sscanf2 ("2200*y^4*t^2 + 2640*y^3*z*t^2 + 38304*y^3*t - 1536*y^3 - 1980*y^2*z^2*t^2 + 71820*y^2*z*t + 2304*y^2*z + 155034*y^2 - 4048*y*z^3*t^2 + 33408*y*z^2*t - 1920*y*z^2 + 361746*y*z + 1188*z^4*t^2 - 43740*z^3*t + 576*z^3 + 317115*z^2", "%Az", &B);

    bap_gcd_polynom_mpz (&G, &cofA, &cofB, &A, &B);
    bap_mul_polynom_mpz (&cofA, &cofA, &G);
    bap_sub_polynom_mpz (&cofA, &cofA, &A);
    b = bap_is_zero_polynom_mpz (&cofA);
    bap_mul_polynom_mpz (&cofB, &cofB, &G);
    bap_sub_polynom_mpz (&cofB, &cofB, &B);
    b = b && bap_is_zero_polynom_mpz (&cofB);
    bap_terminate (ba0_init_level);
    return b ? 0 : 1;
}

