#include "bap.h"

#define FNAME "gcd6.in"

int main ()
{   bav_Iordering r;
    struct bap_polynom_mpz A;
    struct bap_polynom_mpz B;
    struct bap_polynom_mpz G;
    struct bap_polynom_mpz cofA;
    struct bap_polynom_mpz cofB;
    static char buffer [4096];
    FILE* f;
    bool b;

    bap_restart (0, 0);
    f = fopen (FNAME, "r");
    if (f == NULL)
	return 1;

    ba0_fscanf2 (f, "%ordering;", &r);
    bav_R_push_ordering (r);

    bap_init_polynom_mpz (&A);
    bap_init_polynom_mpz (&B);

    ba0_fscanf2 (f, "%Az;", &A);
    ba0_fscanf2 (f, "%Az;", &B);

    fclose (f);

    bap_init_polynom_mpz (&G);
    bap_init_polynom_mpz (&cofA);
    bap_init_polynom_mpz (&cofB);

    bap_gcd_polynom_mpz (&G, &cofA, &cofB, &A, &B);
    ba0_sprintf (buffer, "%Az", &G);
    b = strcmp ("v[t,t,t]*v[t] + v[x,y]*v[t]^2 - v[x,t]*v[y]*v[t] - 4*v[t,t]^2 + v[t,t]*v[t]", buffer) == 0;

    bap_mul_polynom_mpz (&cofA, &cofA, &G);
    bap_sub_polynom_mpz (&cofA, &cofA, &A);
    b = b && bap_is_zero_polynom_mpz (&cofA);
    bap_mul_polynom_mpz (&cofB, &cofB, &G);
    bap_sub_polynom_mpz (&cofB, &cofB, &B);
    b = b && bap_is_zero_polynom_mpz (&cofB);
    bap_terminate (ba0_init_level);
    return b ? 0 : 1;
}

