#include "bap.h"

int main ()
{   bap_polynom_mpz A;
    struct bav_tableof_variable nulles;
    bav_symbol t;
    bav_Iordering r;
    char buffer1 [4096], buffer2 [4096];
    ba0_int_p i, j;
    struct ba0_mark M;

    bap_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [t], blocks = [a,b,c,d,e,f,g,h])", 
		 "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_sscanf2 ("t", "%y", &t);

    ba0_record (&M);
    ba0_init_table ((ba0_table)&nulles);

    A = bap_new_polynom_mpz ();

    for (i = 0; i < 7; i++)
    {	if (i == 1)
	    bap_push_clot_parameters_stack 
		(bap_basic_termanager, bap_decreasing_monom_sequence);
	else if (i == 2)
	    bap_push_clot_parameters_stack
		(bap_hashing_termanager, bap_decreasing_monom_sequence);
	else if (i == 3)
	    bap_push_clot_parameters_stack
		(bap_zipping_termanager, bap_decreasing_monom_sequence);
	else if (i == 4)
	    bap_push_clot_parameters_stack
		(bap_hashing_termanager, bap_decreasing_monom_sequence);
	else if (i == 5)
	    bap_push_clot_parameters_stack
		(bap_basic_termanager, bap_decreasing_monom_sequence);
	else if (i == 6)
	    bap_push_clot_parameters_stack
		(bap_zipping_termanager, bap_decreasing_monom_sequence);

	ba0_sscanf2 ("a^2+b^2+c^2+d^2+e^2+f^2+g^2+h^2", "%Az", A);
	for (j = 0; j < 8; j++)
	{   ba0_alloc (1);
	    bap_diff_polynom_mpz (A, A, t, &nulles);
	}

	if (i == 0)
	    ba0_sprintf (buffer1, "%Az", A);
	ba0_garbage ("%Az", &M, &A);
	ba0_sprintf (buffer2, "%Az", A);
	if (strcmp (buffer1, buffer2) != 0)
	    return 1;
    }
    bav_R_pull_ordering ();
    bap_terminate (ba0_init_level);
    return 0;
}
