#include "bap.h"

int main ()
{
    bav_Iordering r;
    bav_variable v;
    struct bap_ratfrac_mpz Q, S;
    char buffer [256];

    bap_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [x,y], blocks = [u, v])",
		 "%ordering", &r);

    bav_R_push_ordering (r);
    bap_init_ratfrac_mpz (&Q);
    bap_init_ratfrac_mpz (&S);

    ba0_sscanf2 ("u[x] +v/u[y]", "%Qz", &Q);
    ba0_sscanf2 ("v", "%v", &v);

    bap_separant2_ratfrac_mpz (&S, &Q, v);
    ba0_sprintf (buffer, "%Qz", &S);
    if (strcmp (buffer, "(1)/(u[y])") != 0)
	return 1;
    bav_R_pull_ordering ();
    bap_terminate (ba0_init_level);
    return 0;
}
