#include "bap.h"

int main ()
{   struct bap_product_mpz prod;
    struct bap_polynom_mpz P;
    bav_Iordering r;
    static char buffer [512];
    bool b;

    bap_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [], blocks = [x,y,z])",
		 "%ordering", &r);
    bav_R_push_ordering (r);

    bap_init_product_mpz (&prod);
    bap_init_polynom_mpz (&P);
    ba0_sscanf2 ("(z+y+1)*17*(x+y)^3*(x-y)^2*(x^2+x+7)^4", "%Az", &P);
    bap_squarefree_polynom_mpz (&prod, &P);

    ba0_sprintf (buffer, "%Pz", &prod);
    b = strcmp (buffer, "(x - y)^2*(x + y)^3*(x^2 + x + 7)^4*(17*y + 17*z + 17)") == 0;
    bap_terminate (ba0_init_level);
    return b ? 0 : 1;
}
