#ifndef BAV_BLOCK_H
#define BAV_BLOCK_H 1

#include "bav_common.h"
#include "bav_symbol.h"
#include "bav_subranking.h"

BEGIN_C_DECLS

typedef struct bav_block {
    bav_subranking subr;
    struct ba0_tableof_int_p indices;
    struct ba0_tableof_string strs;
} *bav_block;

#define BAV_NOT_A_BLOCK (bav_block)0

typedef struct bav_tableof_block {
    ba0_int_p alloc;
    ba0_int_p size;
    bav_block *tab;
} *bav_tableof_block;

extern  BAV_DLL void bav_init_block (bav_block);
extern  BAV_DLL void bav_reset_block (bav_block);
extern  BAV_DLL bav_block bav_new_block (void);
extern  BAV_DLL bool bav_is_empty_block (bav_block);

extern  BAV_DLL ba0_scanf_function bav_scanf_block;
extern  BAV_DLL ba0_printf_function bav_printf_block;

END_C_DECLS

#endif /* !BAV_BLOCK_H */
