#ifndef BAV_EV_POINT_H
#define BAV_EV_POINT_H 1

#include "bav_common.h"
#include "bav_variable.h"

BEGIN_C_DECLS

struct bav_ev_value {
    bav_variable var;
    ba0_int_p value;
};

typedef struct bav_ev_point {
    ba0_int_p alloc;
    ba0_int_p size;
    struct bav_ev_value *tab;
} *bav_ev_point;

extern BAV_DLL void bav_init_ev_point (bav_ev_point);
extern BAV_DLL void bav_realloc_ev_point (bav_ev_point, ba0_int_p);
extern BAV_DLL void bav_set_ev_point (bav_ev_point, bav_ev_point);
extern BAV_DLL void bav_shift_ev_point (bav_ev_point, bav_ev_point);

extern BAV_DLL ba0_scanf_function bav_scanf_ev_point;
extern BAV_DLL ba0_printf_function bav_printf_ev_point;
extern BAV_DLL ba0_garbage2_function bav_garbage2_ev_point;
extern BAV_DLL ba0_garbage1_function bav_garbage1_ev_point;
extern BAV_DLL ba0_copy_function bav_copy_ev_point;

END_C_DECLS
#endif /* !BAV_EV_POINT_H */
