#ifndef BAV_HTERM_H
#define BAV_HTERM_H 1

#include "bav_term.h"

BEGIN_C_DECLS

typedef ba0_int_p bav_hash_code;

#define bav_tableof_hash_code	ba0_tableof_int_p

typedef struct bav_htableof_term {
   struct _G {
	ba0_int_p alloc;
	ba0_int_p size;
	ba0_int_p* index_in_H;
	ba0_int_p* hack;
   } G;
   struct _H {
	ba0_int_p alloc;
	ba0_int_p size;
	bav_hash_code* code;
	bav_term*  term;
   } H;
} *bav_htableof_term;

#define bav_term_stack	bav_global.hterm.stack
#define bav_hterm 	bav_global.hterm.htable

extern BAV_DLL void bav_init_htableof_term (bav_htableof_term);
extern BAV_DLL void bav_reset_htableof_term (bav_htableof_term);
extern BAV_DLL void bav_clear_htableof_term (bav_htableof_term);
extern BAV_DLL ba0_int_p bav_nbelem_htableof_term (bav_htableof_term);
extern BAV_DLL void bav_resize_htableof_term (bav_htableof_term, ba0_int_p);

extern BAV_DLL bav_hash_code bav_hash_term (bav_term);
extern BAV_DLL void bav_unhash_term (bav_term, bav_hash_code);

END_C_DECLS

#endif /* !BAV_HTERM_H */
