#include "bav.h"

int main ()
{   bav_Iordering r;
    bav_term T, U;
    bav_hash_code code;
    bool b;

    bav_restart (0, 0);

    ba0_sscanf2 
	("ordering (derivations = [x,y], blocks = [u,v], varmax = [v[x,y]])",
	 "%ordering", &r);
    bav_R_push_ordering (r);

    T = bav_new_term ();
    U = bav_new_term ();

    ba0_sscanf2 ("u[x]*v[x]*u[x]*x*u", "%term", T);
    code = bav_hash_term (T);
    bav_unhash_term (U, code);
    b = bav_equal_term (T, U);
    if (! b)
	goto fin;
    bav_resize_htableof_term (&bav_hterm, bav_hterm.H.size + 1);
    code = bav_hash_term (T);
    bav_unhash_term (U, code);
    b = bav_equal_term (T, U);
    if (! b)
        goto fin;

    ba0_sscanf2 ("u[x]*v[x]*v[x,y]*v[x,x,y]*u[x]*x*u", "%term", T);
    code = bav_hash_term (T);
    bav_unhash_term (U, code);
    b = bav_equal_term (T, U);
    if (! b)
	goto fin;
    bav_resize_htableof_term (&bav_hterm, bav_hterm.H.size + 1);
    code = bav_hash_term (T);
    bav_unhash_term (U, code);
    b = bav_equal_term (T, U);
fin:
    bav_R_pull_ordering ();
    bav_terminate (ba0_init_level);
    return b ? 0 : 1;
}

