#include "bav.h"

char buffer [512];

int main ()
{   bav_Iordering r;
    bav_variable a, b;
    bav_tableof_variable T;
    struct ba0_mark M;
    bool tst;

    bav_restart (0, 0);
    ba0_record (&M);
    ba0_sscanf2 ("ordering (derivations = [], blocks = [z])",
		    "%ordering", &r);
    bav_R_push_ordering (r);

    a = bav_R_new_temporary_variable ();
    b = bav_R_new_temporary_variable ();

    ba0_alloc (1);
    T = (bav_tableof_variable)ba0_new_table ();
    ba0_scanf_printf ("%t[%v]", "[%v, z, %v]", T, a, b);

    ba0_sprintf (buffer, "%t[%v]", T);
    tst = strcmp (buffer, "[_[0], z, _[1]]") == 0;

    bav_sort_tableof_variable (T, ba0_ascending_mode);
    ba0_garbage ("%t[%v]", &M, &T);
    ba0_sprintf (buffer, "%t[%v]", T);
    tst = tst && strcmp (buffer, "[_[1], _[0], z]") == 0;

    bav_R_free_temporary_variable (a);
    a = bav_R_new_temporary_variable ();
    ba0_sprintf (buffer, "%v", a);
    tst = tst && strcmp (buffer, "_[0]") == 0;

    bav_R_set_maximal_variable (a);
    bav_sort_tableof_variable (T, ba0_ascending_mode);
    ba0_sprintf (buffer, "%t[%v]", T);
    tst = tst && strcmp (buffer, "[_[1], z, _[0]]") == 0;

    bav_terminate (ba0_init_level);
    return tst ? 0 : 1;
}

