#include "bav.h"

int main ()
{   bav_Iordering r;
    static char buffer [256];
    bav_term T;
    struct ba0_mark M;

    bav_restart (0, 0);

    ba0_sscanf2 
	("ordering (derivations = [x,y], blocks = [u,v], varmax = [v[x,y]])", 
	 "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_record (&M);

    T = bav_new_term ();
    ba0_sscanf2 ("u[x]*v[x]*u[x]*x*u", "%term", T);
    ba0_sprintf (buffer, "%term", T);
    if (strcmp (buffer, "u[x]^2*u*v[x]*x") != 0)
	return 1;

    ba0_garbage ("%term", &M, &T);
    ba0_sprintf (buffer, "%term", T);
    if (strcmp (buffer, "u[x]^2*u*v[x]*x") != 0)
	return 1;

    ba0_sscanf2 ("u[x]*v[x]*v[x,y]*v[x,x,y]*u[x]*x*u", "%term", T);
    ba0_sprintf (buffer, "%term", T);
    if (strcmp (buffer, "v[x,y]*u[x]^2*u*v[x,x,y]*v[x]*x") != 0)
	return 1;

    ba0_garbage ("%term", &M, &T);
    ba0_sprintf (buffer, "%term", T);
    if (strcmp (buffer, "v[x,y]*u[x]^2*u*v[x,x,y]*v[x]*x") != 0)
	return 1;

    bav_R_pull_ordering ();
    bav_terminate (ba0_init_level);
    return 0;
}

