#include "bav.h"

int main ()
{   bav_Iordering r;
    static char buffer [256];
    bav_term T;
    struct ba0_mark M;

    bav_restart (0, 0);

    ba0_sscanf2 
	("ordering (derivations = [x[1],y], blocks = [u,v[2,-3]], varmax = [v[2,-3][x[1],y]])", 
	 "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_record (&M);

    T = bav_new_term ();
    ba0_sscanf2 ("u[x[1]]*v[2,-3][x[1]]*u[x[1]]*x[1]*u", "%term", T);
    ba0_sprintf (buffer, "%term", T);
    if (strcmp (buffer, "u[x[1]]^2*u*v[2,-3][x[1]]*x[1]") != 0)
	return 1;

    ba0_garbage ("%term", &M, &T);
    ba0_sprintf (buffer, "%term", T);
    if (strcmp (buffer, "u[x[1]]^2*u*v[2,-3][x[1]]*x[1]") != 0)
	return 1;

    ba0_sscanf2 ("u[x[1]]*v[2,-3][x[1]]*v[2,-3][x[1],y]*v[2,-3][x[1],x[1],y]*u[x[1]]*x[1]*u", "%term", T);
    ba0_sprintf (buffer, "%term", T);
    if (strcmp (buffer, "v[2,-3][x[1],y]*u[x[1]]^2*u*v[2,-3][x[1],x[1],y]*v[2,-3][x[1]]*x[1]") != 0)
	return 1;

    ba0_garbage ("%term", &M, &T);
    ba0_sprintf (buffer, "%term", T);
    if (strcmp (buffer, "v[2,-3][x[1],y]*u[x[1]]^2*u*v[2,-3][x[1],x[1],y]*v[2,-3][x[1]]*x[1]") != 0)
	return 1;

    bav_R_pull_ordering ();
    bav_terminate (ba0_init_level);
    return 0;
}

