#include "bav.h"

static int compar (const void* a, const void* b)
{   bav_term T = *(bav_term*)a,
	     U = *(bav_term*)b;
    enum ba0_compare_code code;

    code = bav_compare_term (T, U);
    return code == ba0_lt ? 1 : code == ba0_eq ? 0 : -1;
}

int main ()
{   bav_Iordering r;
    static char buffer [256];
    struct bav_tableof_term T;
    bool b;

    bav_restart (0, 0);
        ba0_sscanf2
        ("ordering (derivations = [x,y], blocks = [u,v], varmax = [v[x,y]])",
         "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_init_table ((ba0_table)&T);
    ba0_sscanf2 ("[v[x,y]*u[x]^2*u*v[x,x,y]*v[x]*x, \
		   v[x,y]*u[x,x]*v[x,x,y]*v[x], \
		   v[x,y]*u[x]^2*v[x]^2*x, \
		   v[x,y]*u[x]*v[x,x,y]^2*v[x]*x]", "%t[%term]", &T);
    
    qsort (T.tab, T.size, sizeof (bav_term), &compar);
    ba0_sprintf (buffer, "%t[%term]", &T);
    b = strcmp (buffer, "[v[x,y]*u[x,x]*v[x,x,y]*v[x], v[x,y]*u[x]^2*u*v[x,x,y]*v[x]*x, v[x,y]*u[x]^2*v[x]^2*x, v[x,y]*u[x]*v[x,x,y]^2*v[x]*x]") == 0;
    if (! b) goto fin;

    bav_set_term_ordering ("grlex");
    qsort (T.tab, T.size, sizeof (bav_term), &compar);
    ba0_sprintf (buffer, "%t[%term]", &T);
    b = strcmp (buffer, "[v[x,y]*u[x]^2*u*v[x,x,y]*v[x]*x, v[x,y]*u[x]^2*v[x]^2*x, v[x,y]*u[x]*v[x,x,y]^2*v[x]*x, v[x,y]*u[x,x]*v[x,x,y]*v[x]]") == 0;
    if (! b) goto fin;

    bav_set_term_ordering ("degrevlex");
    qsort (T.tab, T.size, sizeof (bav_term), &compar);
    ba0_sprintf (buffer, "%t[%term]", &T);
    b = strcmp (buffer, "[v[x,y]*u[x]^2*u*v[x,x,y]*v[x]*x, v[x,y]*u[x]*v[x,x,y]^2*v[x]*x, v[x,y]*u[x]^2*v[x]^2*x, v[x,y]*u[x,x]*v[x,x,y]*v[x]]") == 0;

fin:
    bav_R_pull_ordering ();
    bav_terminate (ba0_init_level);
    return b ? 0 : 1;
}
