#include "blad.h"

/*
   Variant of bad_pardi_ex (look at this file).
   The exception raised here is due to an out-of-time error.
*/

int main ()
{   bav_Iordering r, rbar;
    bad_regchain C, Cbar;
    struct ba0_mark M;
    struct ba0_exception_code code;

/*
   Given limits are: 1 second and 1 Mb.
*/
    bad_restart (1, 100);
    BA0_PUSH_EXCEPTION (code);
    if (ba0_exception_is_raised (code))
    {	fprintf (stderr, "exception caught: %s\n", ba0_mesgerr);
	exit (1);
    }
/*
  infinite loop
*/
    for (;;)
    {	ba0_record (&M);
	ba0_alloc (10);
	ba0_restore (&M);
    }

    ba0_sscanf2 
	("ordering (derivations = [x,y], blocks = [[v, u]])", "%ordering", &r);
    ba0_sscanf2 
	("ordering (derivations = [x,y], blocks = [u, v])", "%ordering", &rbar);
    bav_R_push_ordering (r);
    C = bad_new_regchain ();
    ba0_sscanf2 ("regchain ([v[x,x]-u[x], 4*v[y]*u+u[x]*u[y]-u[x]*u[y]*u, u[x]^2-4*u, u[y]^2-2*u], [differential, prime, autoreduced, primitive, squarefree, coherent])", "%regchain", C);
    ba0_printf ("before: %regchain\n\n", C);
    Cbar = bad_new_regchain ();
    ba0_sscanf2 ("regchain ([], [autoreduced, primitive])", "%regchain", Cbar);
    bad_pardi (Cbar, rbar, C);
    ba0_garbage ("%regchain", &M, &Cbar);
    ba0_printf ("after: %regchain\n", Cbar);
    bav_R_pull_ordering ();
    ba0_pull_exception (code);
    bad_terminate (ba0_init_level);
    return 0;
}

