#include "bav.h"

int main ()
{
    struct ba0_mark M;
    bav_tableof_variable T;
    bav_Iordering r, s, t;

    bav_restart (0, 0);
    ba0_record (&M);
/*
  The two first orderings are rankings. The last one is not.
*/
    ba0_sscanf2 
	("ordering (derivations = [x,y], blocks = [u,v])", "%ordering", &r);
    ba0_sscanf2 
	("ordering (derivations = [x,y], blocks = [v,u])", "%ordering", &s);
    ba0_sscanf2 
	("ordering (derivations = [x,y], blocks = [v,u], varmax = [u[x]])", 
	 "%ordering", &t);
/*
   The format string %t[%v] indicates a table of variables.
*/
    bav_R_push_ordering (r);
    T = (bav_tableof_variable)ba0_new_table ();
    ba0_sscanf2 ("[u[x], u[x,y], u, v, v[y], v[x,y]]", "%t[%v]", T);
    bav_sort_tableof_variable (T, ba0_ascending_mode);
    ba0_printf ("w.r.t. ordering: %ordering\ntable sorted increasinlgly = %t[%v]\n", r, T);
    bav_R_push_ordering (s);
    bav_sort_tableof_variable (T, ba0_ascending_mode);
    ba0_printf ("w.r.t. ordering: %ordering\ntable sorted increasinlgly = %t[%v]\n", s, T);
    bav_R_push_ordering (t);
    bav_sort_tableof_variable (T, ba0_ascending_mode);
    ba0_printf ("w.r.t. ordering: %ordering\ntable sorted increasinlgly = %t[%v]\n", t, T);

    bav_terminate (ba0_init_level);
    return 0;
}

