#ifndef BA0_LIST_H
#define BA0_LIST_H

#include "ba0_common.h"

BEGIN_C_DECLS

typedef struct ba0_list {
    void* value;
    struct ba0_list* next;
} *ba0_list;

extern BA0_DLL ba0_list ba0_sort_list (ba0_list, ba0_cmp_function*);
extern BA0_DLL ba0_list ba0_select_list (ba0_list, ba0_unary_predicate*);
extern BA0_DLL ba0_list ba0_delete_list (ba0_list, ba0_unary_predicate*);
extern BA0_DLL ba0_list ba0_insert_list (void*, ba0_list, ba0_cmp_function*);
extern BA0_DLL bool ba0_member_list (void*, ba0_list);
extern BA0_DLL void* ba0_last_list (ba0_list);
extern BA0_DLL ba0_list ba0_butlast_list (ba0_list);
extern BA0_DLL ba0_list ba0_copy_list (ba0_list);
extern BA0_DLL ba0_list ba0_cons_list (void*, ba0_list);
extern BA0_DLL ba0_list ba0_endcons_list (void*, ba0_list);
extern BA0_DLL ba0_list ba0_reverse_list (ba0_list);
extern BA0_DLL ba0_list ba0_concat_list (ba0_list, ba0_list);
extern BA0_DLL void ba0_move_to_head_list (ba0_list, ba0_int_p);
extern BA0_DLL ba0_int_p ba0_length_list (ba0_list);
extern BA0_DLL void* ba0_ith_list (ba0_list, ba0_int_p);
extern BA0_DLL ba0_list ba0_map_list (ba0_unary_function*, ba0_list);

END_C_DECLS

#endif /* !BA0_LIST_H */
