#include "ba0.h"

int main ()
{
    ba0_arrayof_double A, B;
    ba0_array C;
    struct ba0_mark M;
    static char buffer [1024];
    bool b;

    ba0_restart (0, 0);
    ba0_record (&M);

    A = (ba0_arrayof_double)ba0_new_array ();
    ba0_sscanf2 ("[3.1, 0., 1e0]", "%a[%le]", A);

    ba0_sprintf (buffer, "%a[%le]", A);
    b = A->tab [0] == 3.1 && A->tab [1] == 0 && A->tab [2] == 1;

    ba0_concat_array ((ba0_array)A, (ba0_array)A, (ba0_array)A);
    ba0_garbage ("%a[%le]", &M, &A);
    ba0_sprintf (buffer, "%a[%le]", A);
    b = b && A->tab [0] == 3.1 && A->tab [1] == 0 && A->tab [2] == 1 &&
	     A->tab [3] == 3.1 && A->tab [4] == 0 && A->tab [5] == 1;

    B = (ba0_arrayof_double)ba0_new_array ();
    
    ba0_reverse_array ((ba0_array)A, (ba0_array)A);
    ba0_reverse_array ((ba0_array)A, (ba0_array)A);
    b = b && A->tab [0] == 3.1 && A->tab [1] == 0 && A->tab [2] == 1 &&
             A->tab [3] == 3.1 && A->tab [4] == 0 && A->tab [5] == 1;

    ba0_reverse_array ((ba0_array)B, (ba0_array)A);
    ba0_reverse_array ((ba0_array)B, (ba0_array)B);
    b = b && B->tab [0] == 3.1 && B->tab [1] == 0 && B->tab [2] == 1 &&
	     B->tab [3] == 3.1 && B->tab [4] == 0 && B->tab [5] == 1;

    ba0_delete_array ((ba0_array)B, 3);
    b = b && B->tab [0] == 3.1 && B->tab [1] == 0 && B->tab [2] == 1 &&
	     B->tab [3] == 0 && B->tab [4] == 1 && B->size == 5;

    C = ba0_new_array ();
    ba0_sscanf2 ("[2, 3, 1]", "%a[%d]", C);
    ba0_sprintf (buffer, "%a[%d]", C);
    b = b && strcmp (buffer, "[2, 3, 1]") == 0;

    ba0_garbage ("%a[%d]", &M, &C);
    ba0_sprintf (buffer, "%a[%d]", C);
    b = b && strcmp (buffer, "[2, 3, 1]") == 0;

    ba0_terminate (ba0_init_level);
    return b ? 0 : 1;
}

