#include "ba0.h"

int main ()
{   ba0_mpzm_t a, b;
    __mpz_struct* c;
    ba0_mpz_t ddz;
    ba0_mpq_t q;
    struct ba0_mark M;
    char buffer [32];

    ba0_restart (0, 0);
    ba0_record (&M);
    ba0_mpzm_module_set_ui (101, true);
    
    ba0_mpzm_init_set_ui(a, 17);
    ba0_mpzm_init_set_ui(b, 6);

    ba0_mpzm_mul (a, a, b);
    if (ba0_mpzm_cmp_ui (a, 1) != 0)
	return 1;

    c = ba0_new_mpzm ();
    ba0_mpzm_set_si(c, 17);
    ba0_garbage ("%zm", &M, &c);

    ba0_mpq_init (q);
    ba0_mpz_init (ddz);
    if (ba0_wang_mpzm (q, c, ddz) != ba0_rational_found)
	return 1;

    ba0_sprintf (buffer, "%q", q);
    if (strcmp (buffer, "1/6") != 0)
	return 1;

    ba0_terminate (ba0_init_level);
    return 0;
}

