#ifndef BAD_NONZERO_H
#define BAD_NONZERO_H 1

#include "bad_common.h"

BEGIN_C_DECLS

typedef bool bad_nonzero_function (bap_polynom_mpz);

#define	bad_nonzero		bad_initialized_global.nonzero.function
#define bad_nonzero_data	bad_initialized_global.nonzero.data

extern BAD_DLL void bad_set_settings_nonzero (bad_nonzero_function*, void*);
extern BAD_DLL void bad_get_settings_nonzero (bad_nonzero_function**, void**);

extern BAD_DLL bad_nonzero_function bad_nonzero_default;
extern BAD_DLL bad_nonzero_function bad_nonzero_tabvars;
extern BAD_DLL bad_nonzero_function bad_nonzero_reduced_polynom_base_field;
extern BAD_DLL bad_nonzero_function bad_nonzero_polynom_base_field;

END_C_DECLS

#endif /* !BAD_NONZERO_H */
