#include "bad.h"

int main ()
{   struct bad_base_field K;
    struct bad_regchain A;
    struct bad_intersectof_regchain T;
    bav_Iordering r;
    struct bap_tableof_polynom_mpz eqns, ineqns;
    struct bav_tableof_variable S;
    static char buffer [512];
    bool b;

    bad_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [t], blocks = [u, [s, c]])",
		 "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_init_table ((ba0_table)&eqns);
    ba0_sscanf2 ("[u[t]^2 - s*u, s[t] - c, c[t] + s]", "%t[%Az]", &eqns);
    ba0_init_table ((ba0_table)&ineqns);

    bad_init_intersectof_regchain (&T);
    ba0_sscanf2 ("intersectof_regchain ([], [differential, autoreduced, primitive, squarefree, normalized])", "%intersectof_regchain", &T);

    bad_Rosenfeld_Groebner 
	(&T, &eqns, &ineqns, (bad_base_field)0, (bad_splitting_control)0);

    ba0_sprintf (buffer, "%intersectof_regchain_equations", &T);
    b = strcmp (buffer, "[[c[t] + s, s[t] - c, u[t]^2 - u*s], [c[t] + s, s[t] - c, u], [c, s, u[t]]]") == 0 || strcmp (buffer, "[[c[t] + s, s[t] - c, u[t]^2 - u*s], [c, s, u[t]], [c[t] + s, s[t] - c, u]]") == 0;

    bad_init_base_field (&K);
    bad_init_regchain (&A);
    ba0_sscanf2 ("regchain ([s[t] - c, c[t] + s], [differential, prime, autoreduced, primitive, squarefree, normalized])", "%pretend_regchain", &A);
    bad_set_base_field_generators_and_relations 
	(&K, (bav_tableof_variable)0, &A, (bav_tableof_parameter)0, true, false);

    ba0_sprintf (buffer, "%base_field", &K);
    b = b && strcmp (buffer, "field (differential = true, generators = [s, c], relations = regchain ([c[t] + s, s[t] - c], [differential, prime, autoreduced, primitive, squarefree, normalized]))") == 0;

    ba0_sscanf2 (buffer, "%base_field", &K);

    ba0_init_table ((ba0_table)&S);
    bad_base_field_implicit_generators 
			(&S, &K, (bav_tableof_variable)0, (bad_regchain)0);
    ba0_sprintf (buffer, "%t[%v]", &S);

    b = b && 
	(strcmp (buffer, "[s, c]") == 0 || strcmp (buffer, "[c, s]") == 0);

    bad_Rosenfeld_Groebner (&T, &eqns, &ineqns, &K, (bad_splitting_control)0);

    ba0_sprintf (buffer, "%intersectof_regchain_equations", &T);
    b = b && strcmp (buffer, "[[c[t] + s, s[t] - c, u[t]^2 - u*s], [c[t] + s, s[t] - c, u]]") == 0;

    return b ? 0 : 1;
}
