#include "bad.h"

int main ()
{
    bav_Iordering r;
    bap_tableof_polynom_mpz eqns;
    struct bad_base_field K;
    bad_intersectof_regchain T;
    struct ba0_mark M;
    char buffer [512];
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);

    bad_reduction_strategy = bad_gcd_prem_and_factor_reduction_strategy;

    ba0_sscanf2 ("ordering (derivations = [x], blocks = [[z,y]])",
		 "%ordering", &r);

    bav_R_push_ordering (r);
    eqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ba0_sscanf2 ("[y[x,x]*(z[x,x]+z)]", "%t[%Az]", eqns);

    T = bad_new_intersectof_regchain ();
    ba0_sscanf2 
	("intersectof_regchain ([], \
		[differential, normalized, squarefree, \
		 coherent, primitive, autoreduced])",
	 "%intersectof_regchain", T);

    bad_init_base_field (&K);
    ba0_sprintf (buffer, "%base_field", &K);

    bad_Rosenfeld_Groebner 
	(T, eqns, (bap_tableof_polynom_mpz)0, &K, (bad_splitting_control)0);

    ba0_sprintf (buffer, "%intersectof_regchain", T);
    b = strcmp (buffer, "intersectof_regchain ([regchain ([z[x,x] + z], [differential, prime, autoreduced, primitive, squarefree, normalized]), regchain ([y[x,x]], [differential, prime, autoreduced, primitive, squarefree, normalized])], [differential, autoreduced, primitive, squarefree, normalized])") == 0;

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
