#include "bad.h"
#include "stdio.h"

int main ()
{
    bav_Iordering r;
    bap_tableof_polynom_mpz eqns;
    bad_intersectof_regchain T;
    bad_regchain C;
    struct bav_rank rg;
    struct ba0_mark M;
    ba0_int_p i, j;
    char buffer [65536], *p;
    bool b;
    static char* output [] = { 
	" k2[t] k1b[t] k1a[t] p[t] c[t,t,t]^2 s e", 
	" k2 k1b[t] k1a[t] p[t] c[t,t,t] s^2 e", 
	" k2[t] k1b[t] k1a[t] c p[t] e s[t]", 
	" k2 k1b[t] k1a[t] c[t] p[t] e s[t]", 
	" k1b k2[t] k1a[t] c[t] p[t] e s[t]", 
	" k2 k1b[t] k1a[t] p[t] c[t,t]^2 s e", 
	" k2[t] k1b[t] k1a[t] c p[t] s e[t]", 
	" k1b k2[t] k1a[t] c[t] p[t] s e[t]", 
	" k1a k2[t] k1b[t] c[t] p[t] s[t] e[t]" };
 

    bad_restart (0, 0);
    ba0_record (&M);
    bad_reduction_strategy = bad_gcd_prem_and_factor_reduction_strategy;
    ba0_sscanf2 ("ordering (derivations = [t], \
			blocks = [[e,s],[p,c],[k1a,k1b,k2]])",
                 "%ordering", &r);
    bav_R_push_ordering (r);
    eqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ba0_sscanf2 ("[e[t]+k1a*e*s-k1b*c+k2*c,s[t]+k1a*e*s-k1b*c,c[t]-k1a*e*s+k1b*c-k2*c,p[t]-k2*c,k1a[t],k1b[t],k2[t]]", "%t[%Az]", eqns);
    T = bad_new_intersectof_regchain ();
    ba0_sscanf2
        ("intersectof_regchain ([], \
                [differential, squarefree, coherent, normalized, \
		 primitive, autoreduced])",
         "%intersectof_regchain", T);
    bad_Rosenfeld_Groebner
        (T, eqns, (bap_tableof_polynom_mpz)0, 
	 (bad_base_field)0, (bad_splitting_control)0);
    b = T->inter.size == sizeof (output) / sizeof (char*);
    for (i = 0; b && i < T->inter.size; i++)
    {	buffer [0] = '\0';
	C = T->inter.tab [i];
	for (j = 0; j < C->decision_system.size; j++)
	{   rg = bap_rank_polynom_mpz (C->decision_system.tab [j]);
	    p = &buffer [strlen (buffer)];
	    ba0_sprintf (p, " %rank", &rg);
	}
	b = false;
	for (j = 0; (!b) && j < sizeof (output) / sizeof (char*); j++)
	    b = strcmp (output [j], buffer) == 0;
    }

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
