/* File inverse_algebrique.c */

#include "bad.h"

int main ()
{   bav_Iordering r;
    struct bad_regchain C;
    struct bap_product_mpz U, G;
    struct bap_tableof_polynom_mpz T;
    struct bap_polynom_mpz zero;
    bap_polynom_mpz ddz;
    struct ba0_exception_code code;
    struct ba0_mark M;
    bool ok;
    int i;

    bad_restart (0, 0);
    ba0_record (&M);

    ba0_sscanf2 ("ordering (derivations = [], blocks = [x2, x1])",
		 "%ordering", &r);
    bav_R_push_ordering (r);
    bad_init_regchain (&C);
    ba0_sscanf2 ("regchain ([x2^2 + x1 - 2, x1^2 - 1], [])", "%regchain", &C);
    ba0_init_table ((ba0_table)&T);
    bap_init_product_mpz (&U);
    bap_init_product_mpz (&G);
    bap_init_polynom_mpz (&zero);

    ba0_sscanf2 ("[3*x2, x1 + x2]", "%t[%Az]", &T);
    ok = true;
    for (i = 0; ok && i < T.size; i++)
    {   BA0_PUSH_EXCEPTION (code);
	if (ba0_exception_is_raised (code))
	{   
/*
	    ba0_printf ("Inversion of %Az failed. ", T.tab [i]);
	    ba0_printf ("Zero divisor found : %Az\n", ddz);
*/
	    ba0_scanf_printf ("%Az", "%Az - (x1 - 1)", &zero, ddz);
	    ok = bap_is_zero_polynom_mpz (&zero);
	} else
	{   bad_invert_polynom_mod_regchain (&U, &G, T.tab [i], &C, &ddz);
	    ba0_pull_exception (code);
/*
	    ba0_printf ("Inversion of %Az succeeded\n", T.tab [i]);
	    ba0_printf 
		("%Pz * %Az = %Pz modulo %regchain\n", &U, T.tab [i], &G, &C);
*/
	    ba0_scanf_printf ("%Az", "%Pz - x2*(x1 + 2)", &zero, &U);
	    ok = bap_is_zero_polynom_mpz (&zero);
	    ba0_scanf_printf ("%Az", "%Pz - 9", &zero, &G);
	    ok = ok && bap_is_zero_polynom_mpz (&zero);
	}
    }

    ba0_restore (&M);
    bad_terminate (ba0_init_level);
    return ok ? 0 : 1;
}
