#include "bad.h"

int main ()
{   struct bad_base_field K;
    struct bad_regchain A;
    struct bad_intersectof_regchain T;
    struct bap_tableof_polynom_mpz eqns, ineqns;
    struct bap_polynom_mpz eqn_art;
    bav_Iordering r;
    struct ba0_mark M;
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);

    bad_reduction_strategy = bad_gcd_prem_and_factor_reduction_strategy;

    ba0_sscanf2 ("ordering (derivations = [t], blocks = [[z1, D, C, B, A], [k1, k2, k3, kstar]])", "%ordering", &r);
    bav_R_push_ordering (r);

    bad_init_regchain (&A);
    ba0_sscanf2 ("regchain ([k1[t], k2[t], k3[t], kstar[t]], [differential, squarefree, coherent, primitive, autoreduced, prime])", "%pretend_regchain", &A);
    bad_init_base_field (&K);
    bad_set_base_field_generators_and_relations 
	(&K, (bav_tableof_variable)0, &A, (bav_tableof_parameter)0, true, false);

    ba0_init_table ((ba0_table)&eqns);
    ba0_sscanf2 ("[k1[t], k2[t], k3[t], kstar[t], A[t] + z1, B[t] - k3*C + z1, C[t] + k3*C - z1, D[t] - k3*C, k1*A*B - k2*C]", "%t[%Az]", &eqns);

    ba0_init_table ((ba0_table)&ineqns);
    ba0_sscanf2 ("[D, C, B, A]", "%t[%Az]", &ineqns);

    bad_init_intersectof_regchain (&T);
    ba0_sscanf2
        ("intersectof_regchain ([], \
                [differential, squarefree, coherent, primitive, autoreduced])",
         "%intersectof_regchain", &T);

    bad_Rosenfeld_Groebner (&T, &eqns, &ineqns, &K, (bad_splitting_control)0);
/*
    for (i = 0; i < T.inter.size; i++)
        ba0_printf ("%t[%Az]\n", &T.inter.tab [i]->decision_system);
*/
    bap_init_polynom_mpz (&eqn_art);
    ba0_sscanf2 ("z1*k2*k1*A+z1*k2*k1*B+z1*k2^2-k3*k1^2*A^2*B-k3*k1*A*B*k2", "%Az", &eqn_art);

    b = T.inter.size == 1 &&
	bad_is_a_reduced_to_zero_polynom_by_regchain 
			(&eqn_art, T.inter.tab [0], bad_full_reduction);

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
