#include "bad.h"

int main ()
{   struct bad_base_field K;
    struct bad_regchain A;
    struct bad_intersectof_regchain T;
    struct bap_tableof_polynom_mpz eqns, ineqns;
    bav_Iordering r;
    struct ba0_mark M;
    bool b;
    char buffer [1024];

    bad_restart (0, 0);
    ba0_record (&M);

    bad_reduction_strategy = bad_gcd_prem_and_factor_reduction_strategy;
    bav_set_settings_variable (&bav_scanf_diff_variable, 0, 0);

    ba0_sscanf2 ("ordering (derivations = [t], blocks = [F[1], [C, E, P, S], [k[1], k[2], k[3]]])", "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_sscanf2 ("[k[1], k[2], k[3]]", "%t[%param]", &bav_parameters);

    bad_init_regchain (&A);
    ba0_sscanf2 ("regchain ([], [differential, squarefree, coherent, primitive, autoreduced, prime])", "%pretend_regchain", &A);
    bad_init_base_field (&K);
    bad_set_base_field_generators_and_relations 
	(&K, (bav_tableof_variable)0, &A, &bav_parameters, true, false);

    ba0_init_table ((ba0_table)&eqns);
    ba0_sscanf2 ("[F[1](t) + diff (E(t), t) - C(t)*k[3], F[1](t) + diff (S(t), t), -F[1](t) + diff (C(t), t) + C(t)*k[3], diff (P(t), t) - C(t)*k[3], F[1](t), -C(t)*k[2] + E(t)*S(t)*k[1]]", "%t[%Az]", &eqns);

    ba0_init_table ((ba0_table)&ineqns);
    ba0_sscanf2 ("[C(t), 1, 1, 1, 1, 1, 1]", "%t[%Az]", &ineqns);

    bad_init_intersectof_regchain (&T);
    ba0_sscanf2
        ("intersectof_regchain ([], \
                [differential, squarefree, coherent, primitive, autoreduced])",
         "%intersectof_regchain", &T);

    bad_Rosenfeld_Groebner (&T, &eqns, &ineqns, &K, (bad_splitting_control)0);

    b = T.inter.size == 1;
    if (b)
    {   ba0_sprintf (buffer, "%t[%Az]", &T.inter.tab [0]->decision_system);
	b = strcmp (buffer, "[k[3][t], k[2][t], k[1][t], S*k[1] + k[2], C + E, P[t] + E*k[3], E[t] + E*k[3], F[1]]") == 0;
    }

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
