#include "bad.h"

int main ()
{   bav_Iordering r;
    bad_regchain C;
    bap_ratfrac_mpz NF, A;
    bap_polynom_mpz ddz;
    struct ba0_mark M;
    struct ba0_exception_code code;
    char buffer [512];
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);

    ba0_sscanf2 ("ordering (derivations = [], blocks = [y,x])",
		 "%ordering", &r);

    bav_R_push_ordering (r);

    C = bad_new_regchain ();
    ba0_sscanf2 ("regchain ([y^2 - x^2, (x - 1)*(x - 2)*(x - 3)], \
		  [autoreduced, primitive])", "%regchain", C);

    A = bap_new_ratfrac_mpz ();
    ba0_sscanf2 ("1/((y - 1)*(y + 4))", "%Qz", A);
    NF = bap_new_ratfrac_mpz ();
    ddz = bap_new_polynom_mpz ();

    BA0_PUSH_EXCEPTION (code);
    if (ba0_exception_is_set (code))
    {	bad_normal_form_ratfrac_mod_regchain (NF, A, C, &ddz);
	b = false;
	ba0_pull_exception (code);
    } else if (ba0_mesgerr == BAD_EXRDDZ)
    {	bap_normal_numeric_primpart_polynom_mpz (ddz, ddz);
	ba0_sprintf (buffer, "%Az", ddz);
	b = strcmp (buffer, "x - 1") == 0;
    } else
	b = false;

    if (! b) goto fin;
/*
   Same example with an extra push_another_heap_stack to check in the
   corners the behavior of BA0_RAISE_EXCEPTION2.
*/
    bap_set_polynom_zero_mpz (ddz);
    buffer [0] = '\0';

    BA0_PUSH_EXCEPTION (code);
    if (ba0_exception_is_set (code))
    {   ba0_push_another_stack ();
	bad_normal_form_ratfrac_mod_regchain (NF, A, C, &ddz);
        b = false;
        ba0_pull_exception (code);
    } else if (ba0_mesgerr == BAD_EXRDDZ)
    {   bap_normal_numeric_primpart_polynom_mpz (ddz, ddz);
        ba0_sprintf (buffer, "%Az", ddz);
        b = strcmp (buffer, "x - 1") == 0;
    } else
        b = false;
fin:
    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}

