#include "bad.h"

int main ()
{   bav_Iordering r;
    bad_regchain C;
    bap_ratfrac_mpz NF, A;
    bap_polynom_mpz ddz;
    struct ba0_mark M;
    struct ba0_exception_code code;
    char buffer [512];
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);

    ba0_sscanf2 ("ordering (derivations = [x,y], blocks = [[v, u]])",
		 "%ordering", &r);

    bav_R_push_ordering (r);

    C = bad_new_regchain ();
    ba0_sscanf2 ("regchain ([u[y]^2-2*u, u[x]^2-4*u, 4*v[y]*u-u[x]*u[y]*u+u[x]*u[y], v[x,x]-u[x]],[differential, autoreduced, primitive, squarefree, coherent, normalized])", "%pretend_regchain", C);
    A = bap_new_ratfrac_mpz ();
    ba0_sscanf2 ("1/v[y,y,y]", "%Qz", A);
    NF = bap_new_ratfrac_mpz ();
    ddz = bap_new_polynom_mpz ();

    BA0_PUSH_EXCEPTION (code);
    if (ba0_exception_is_set (code))
    {	bad_normal_form_ratfrac_mod_regchain (NF, A, C, &ddz);
	ba0_pull_exception (code);
	ba0_sprintf (buffer, "%Qz", NF);
	b = strcmp (buffer, "(u[x]*u[y])/(2*u)") == 0;
    } else
	b = false;

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}

