#include "bad.h"

int main ()
{   bav_Iordering r;
    bad_regchain C;
    bap_ratfrac_mpz A, NF;
    struct ba0_mark M;
    char buffer [4096];
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);

    ba0_sscanf2 ("ordering (derivations = [x,y], blocks = [g])",
		 "%ordering", &r);

    bav_R_push_ordering (r);

    C = bad_new_regchain ();
    ba0_sscanf2 ("regchain ([4*g[y]^2*y-g^4-2*g^2-1, g[x]-2*g^2-2], [differential, prime, autoreduced, normalized, primitive])", "%pretend_regchain", C);

    A = bap_new_ratfrac_mpz ();
    NF = bap_new_ratfrac_mpz ();

    ba0_sscanf2 ("-g[x, y]/g[y]^2", "%Qz", A);
    bad_normal_form_ratfrac_mod_regchain (NF, A, C, (bap_polynom_mpz*)0);
    ba0_sprintf (buffer, "%Qz", NF);
    b = strcmp (buffer, "(-16*g[y]*g*y)/(g^4 + 2*g^2 + 1)") == 0;

    ba0_sscanf2 ("(4*g[x, y]*g^2*y+4*g[x, y]*y-16*g[x]*g[y]*g*y)/(g^6+3*g^4+3*g^2+1)", "%Qz", A);
    bad_normal_form_ratfrac_mod_regchain (NF, A, C, (bap_polynom_mpz*)0);
    ba0_sprintf (buffer, "%Qz", NF);
    b = b && strcmp (buffer, "(-16*g[y]*g*y)/(g^4 + 2*g^2 + 1)") == 0;

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}

