#include "bad.h"

int main ()
{
    struct bad_base_field K;
    bad_intersectof_regchain T;
    bap_tableof_polynom_mpz eqns, nulles;
    bav_Iordering r;
    struct ba0_mark M;
    ba0_int_p i;
    static char buffer [8192];
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);
/*
 * This example blows up if one is not careful with base field reductions
 */
    ba0_sscanf2 ("ordering (derivations = [x], blocks = [u,p])",
		 "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_sscanf2 ("[p]", "%t[%param]", &bav_parameters);

    bad_init_base_field (&K);
/*
    bad_set_base_field_generators_and_relations 
				(&K, 0, 0, &bav_parameters, false);
*/
    bav_set_settings_variable (&bav_scanf_diff_variable, 0, 0);

    eqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ba0_sscanf2 ("[(p-1)*diff(u(x),x)^2-u(x)]", "%t[%Az]", eqns);
    nulles = (bap_tableof_polynom_mpz)ba0_new_table ();
    bap_zero_derivatives_of_tableof_parameter_mpz (nulles, &bav_parameters);
    ba0_concat_table ((ba0_table)eqns, (ba0_table)eqns, (ba0_table)nulles);

    T = bad_new_intersectof_regchain ();
    ba0_sscanf2 
	("intersectof_regchain ([], \
		[differential, squarefree, coherent, primitive, autoreduced])",
	 "%intersectof_regchain", T);

    bad_Rosenfeld_Groebner 
	(T, eqns, (bap_tableof_polynom_mpz)0, &K, (bad_splitting_control)0);

    ba0_sprintf (buffer, "%intersectof_regchain_equations", T);
    b = strcmp (buffer, "[[p[x], u[x]^2*p - u[x]^2 - u], [p - 1, u], [p[x], u]]") == 0 || strcmp (buffer, "[[p[x], u[x]^2*p - u[x]^2 - u], [p[x], u], [p - 1, u]]") == 0;

    for (i = 0; i < T->inter.size; i++)
	bad_remove_zero_derivatives_of_tableof_parameter_from_regchain 
			(T->inter.tab[i], T->inter.tab[i], &bav_parameters);

    ba0_sprintf (buffer, "%intersectof_regchain_equations", T);
    b = b && 
	(strcmp (buffer, "[[u[x]^2*p - u[x]^2 - u], [p - 1, u], [u]]") == 0 ||
	 strcmp (buffer, "[[u[x]^2*p - u[x]^2 - u], [u], [p - 1, u]]") == 0);

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
