#include "bad.h"

int main (int argc, char** argv)
{   bav_Iordering r, rbar;
    bad_regchain C, Cbar;
    ba0_tableof_string D;
    struct ba0_mark M;
    FILE* f;
/*
 * This switches off the test (which takes too much time) by default.
 * To activate the test, just provide a filename as an argument.
 * Then the result will be stored in the file.
 */
    if (argc == 1)
	return 0;

    bad_set_settings_reduction (0, bad_probabilistic_redzero_strategy, 0);
/*
 * First computation, criterion on
 */
    bad_restart (0, 0);
    ba0_record (&M);

    ba0_sscanf2 
	("ordering (derivations = [t,x,y], blocks = [degrevlexB[p,v1,v2]])",
	 "%ordering", &r);
    ba0_sscanf2 
	("ordering (derivations = [t,x,y], blocks = [degrevlexB[p,v1], degrevlexB[v2]])",
	 "%ordering", &rbar);

    bav_R_push_ordering (r);

    C = bad_new_regchain ();
    ba0_sscanf2 
	("regchain ([v1[x] + v2[y], v2[t] + v2[x]*v1 + p[y] + v2[y]*v2, \
		     v1[t] + p[x] + v1[y]*v2 - v2[y]*v1, \
		     p[x,x] + p[y,y] + 2*v2[x]*v1[y] + 2*v2[y]^2], \
		    [differential, prime, autoreduced, primitive])",
		 "%pretend_regchain", C);

    Cbar = bad_new_regchain ();
    D = (ba0_tableof_string)ba0_new_table ();
    ba0_sscanf2 ("[autoreduced, primitive]", "%t[%s]", D);
    bad_set_desired_properties_regchain (Cbar, D);

    bad_pardi (Cbar, rbar, C);

    f = fopen (argv [1], "w");
    if (f)
    {	ba0_fprintf (f, "%regchain\n", Cbar);
        fclose (f);
    } else
	return 1;

    bad_printf_stats (0);

    bav_R_pull_ordering ();
    ba0_restore (&M);
    bad_terminate (ba0_init_level);
    return 0;
}

