#include "bad.h"

/* 
 * Obviously inconsistent systems.
 * Systems with equations and inequations which obviously factor.
 */

int main ()
{
    bav_Iordering r;
    bap_tableof_polynom_mpz eqns, ineqs;
    bad_intersectof_regchain T;
    struct ba0_mark M;
    char buffer [512];
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);

    ba0_sscanf2 ("ordering (derivations = [x,y], blocks = [[v,u]])",
		 "%ordering", &r);

    bav_R_push_ordering (r);
    eqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ba0_sscanf2 ("[u[x]^2 - 4*u, u[x,y]*v[y] - u + 1, 421, v[x,x] - u[x]]",
    		 "%t[%Az]", eqns);
    ineqs = (bap_tableof_polynom_mpz)ba0_new_table ();

    T = bad_new_intersectof_regchain ();
    ba0_sscanf2 
	("intersectof_regchain ([], \
		[differential, squarefree, coherent, primitive, autoreduced])",
	 "%intersectof_regchain", T);

    bad_Rosenfeld_Groebner 
	(T, eqns, ineqs, (bad_base_field)0, (bad_splitting_control)0);

    ba0_sprintf (buffer, "%intersectof_regchain", T);
    b = strcmp (buffer, "intersectof_regchain ([], [differential, autoreduced, primitive, squarefree, coherent])") == 0;

    ba0_sscanf2 ("[u[x]^2 - 4*u, u[x,y]*v[y] - u + 1, x, v[x,x] - u[x]]",
                 "%t[%Az]", eqns);
    bad_Rosenfeld_Groebner
        (T, eqns, ineqs, (bad_base_field)0, (bad_splitting_control)0);

    ba0_sprintf (buffer, "%intersectof_regchain", T);
    b = b && strcmp (buffer, "intersectof_regchain ([], [differential, autoreduced, primitive, squarefree, coherent])") == 0;

    ba0_sscanf2 ("[u[x]^2 - 4*u, u[x,y]*v[y] - u + 1, v[x,x] - u[x]]",
		 "%t[%Az]", eqns);
    ba0_sscanf2 ("[2, 0]", "%t[%Az]", ineqs);
    bad_Rosenfeld_Groebner
        (T, eqns, ineqs, (bad_base_field)0, (bad_splitting_control)0);

    ba0_sprintf (buffer, "%intersectof_regchain", T);
    b = b && strcmp (buffer, "intersectof_regchain ([], [differential, autoreduced, primitive, squarefree, coherent])") == 0;

    ba0_sscanf2 ("[u[x]*(u[x]-1)^2*u[y]]", "%t[%Az]", eqns);
    ba0_sscanf2 ("[v[x]*v[y]]", "%t[%Az]", ineqs);
    bad_Rosenfeld_Groebner
	(T, eqns, ineqs, (bad_base_field)0, (bad_splitting_control)0);

    ba0_sprintf (buffer, "%intersectof_regchain", T);
    b = b && T->inter.size == 3;

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
