#include "bad.h"

int main ()
{
    bav_Iordering r;
    bap_tableof_polynom_mpz eqns;
    bad_splitting_control C;
    bad_intersectof_regchain T;
    struct ba0_mark M;
    char buffer [512];
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);

    ba0_sscanf2 ("ordering (derivations = [x], blocks = [u])",
		 "%ordering", &r);
    bav_R_push_ordering (r);

    eqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ba0_sscanf2 ("[u[x]^2 - 4*u]", "%t[%Az]", eqns);

    T = bad_new_intersectof_regchain ();
    ba0_sscanf2
	("intersectof_regchain ([], \
		[differential, squarefree, coherent, primitive, autoreduced])",
	 "%intersectof_regchain", T);

    C = bad_new_splitting_control ();
    bad_set_first_branch_only_splitting_control (C, true);

    bad_Rosenfeld_Groebner 
	(T, eqns, (bap_tableof_polynom_mpz)0, 
	 (bad_base_field)0, C);

    ba0_sprintf (buffer, "%intersectof_regchain", T);
    b = strcmp (buffer, "intersectof_regchain ([regchain ([u[x]^2 - 4*u], \
[differential, autoreduced, primitive, squarefree])], \
[differential, autoreduced, primitive, squarefree])") == 0;

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
