#include "bad.h"

int main ()
{   struct bad_intersectof_regchain ideal;
    struct bad_splitting_control control;
    struct bad_base_field K;
    struct bad_regchain relations;
    struct bap_tableof_polynom_mpz eqns, ineqs;
    struct bav_tableof_variable params, generators, X;
    bav_Iordering r;
    struct ba0_tableof_string properties;
    bool b;
    static char buffer [4096];

    bad_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [x], blocks = [[_F7, y], _F9, _F10, [_F5, _F4, _F3, _F2], _F1, [_F8, _F6], F, a, n])", "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_init_table ((ba0_table)&params);
    ba0_sscanf2 ("[a, n]", "%t[%v]", &params);
    ba0_scanf_printf ("%t[%param]", "%t[%v]", &bav_parameters, &params);

    bav_set_settings_variable 
		(&bav_scanf_diff_variable, &bav_printf_diff_variable, 0);

    ba0_init_table ((ba0_table)&eqns);
    ba0_sscanf2 ("[diff(_F1(x),x)-_F1(x), diff(_F2(x),x), diff(_F3(x),x), diff(_F4(x),x)*x-_F4(x)*n, _F5(x)^2-x, diff(_F6(x),x)*F(x)-_F6(x)*n*diff(F(x),x), diff(_F7(x),x)*y(x)-_F7(x)*n*diff(y(x),x), diff(_F10(x),x)]", "%t[%Az]", &eqns);

    ba0_init_table ((ba0_table)&properties);
    ba0_sscanf2 ("[differential, normalized]", "%t[%s]", &properties);

    bad_init_regchain (&relations);
    bad_set_and_extend_regchain_tableof_polynom_mpz 
			(&relations, &eqns, 0, &properties, false, false);

    ba0_init_table ((ba0_table)&generators);
    ba0_sscanf2 ("[F(x), a, n]", "%t[%v]", &generators);

    bad_init_base_field (&K);
    bad_set_base_field_generators_and_relations
	(&K, &generators, &relations, &bav_parameters, false, false);

    ba0_sprintf (buffer, "%base_field", &K);

    ba0_init_table ((ba0_table)&X);
    bad_base_field_implicit_generators (&X, &K, &generators, &relations);
    ba0_sprintf (buffer, "%t[%v]", &X);
    b = strcmp (buffer, "[_F9(x), _F8(x)]") == 0;

    ba0_sscanf2 ("[4*_F9(x)*diff(_F9(x),x)*_F1(x)*_F2(x)+a+2*_F3(x)+_F10(x)-2*_F9(x)-2*_F5(x)^3-2*_F7(x)*_F4(x)-2*_F8(x)-2*_F6(x)]", "%t[%Az]", &eqns);

    ba0_init_table ((ba0_table)&ineqs);
    ba0_sscanf2 ("[_F1(x), _F2(x), _F4(x)*x, diff(_F4(x),x), _F4(x), _F5(x)]", "%t[%Az]", &ineqs);

    bad_init_splitting_control (&control);
    bad_init_intersectof_regchain (&ideal);
    ba0_sscanf2 ("intersectof_regchain ([], [differential, normalized])",
		 "%intersectof_regchain", &ideal);
    bad_Rosenfeld_Groebner (&ideal, &eqns, &ineqs, &K, &control);

    ba0_sprintf (buffer, "%intersectof_regchain_equations", &ideal);

    b = b && strcmp (buffer, "[]") == 0;
    return b ? 0 : 1;
}

