#include "bad.h"

/*
 * Trapped a bug in bad_quench_regchain
 */

int main ()
{   struct bad_intersectof_regchain ideal;
    struct bad_splitting_control control;
    struct bad_base_field K;
    struct bad_regchain relations;
    struct bap_tableof_polynom_mpz eqns, ineqs;
    struct bav_tableof_variable params, generators, X;
    bav_Iordering r;
    struct ba0_tableof_string properties;
    bool b;
    static char buffer [4096];

    bad_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [x,t], blocks = [[_F7, _F6, _F5, _F1, _F4, _F2, _F3], phi, k])", "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_init_table ((ba0_table)&params);
    ba0_sscanf2 ("[k]", "%t[%v]", &params);
    ba0_scanf_printf ("%t[%param]", "%t[%v]", &bav_parameters, &params);

    bav_set_settings_variable (&bav_scanf_diff_variable, 0, 0);

    ba0_init_table ((ba0_table)&eqns);
    ba0_sscanf2 ("[diff(phi(x,t),t)]", "%t[%Az]", &eqns);

    ba0_init_table ((ba0_table)&properties);
    ba0_sscanf2 ("[differential, normalized]", "%t[%s]", &properties);

    bad_init_regchain (&relations);
    bad_set_and_extend_regchain_tableof_polynom_mpz 
			(&relations, &eqns, 0, &properties, false, false);

    ba0_init_table ((ba0_table)&generators);
    ba0_sscanf2 ("[phi(x,t),k]", "%t[%v]", &generators);

    bad_init_base_field (&K);
    bad_set_base_field_generators_and_relations
	(&K, &generators, &relations, &bav_parameters, false, false);

    ba0_sprintf (buffer, "%base_field", &K);

    ba0_init_table ((ba0_table)&X);
    bad_base_field_implicit_generators (&X, &K, &generators, &relations);
    ba0_sprintf (buffer, "%t[%v]", &X);
    b = strcmp (buffer, "[]") == 0;

    ba0_sscanf2 ("[_F7(x,t)*_F3(x,t)*_F5(x,t)+_F7(x,t)*_F3(x,t)*_F6(x,t), _F7(x,t)*k*_F4(x,t)^2*_F3(x,t)*_F5(x,t)+_F7(x,t)*k*_F4(x,t)^2*_F3(x,t)*_F6(x,t), _F2(x,t)^2*_F7(x,t)*_F5(x,t)+_F7(x,t)*_F6(x,t)-phi(x,t)*_F2(x,t), _F4(x,t)*_F2(x,t)^2*_F7(x,t)*_F5(x,t)-_F7(x,t)*_F6(x,t)*_F4(x,t)-diff(phi(x,t),x)*_F2(x,t), 2*_F4(x,t)*diff(_F4(x,t),x), 2*_F4(x,t)*diff(_F2(x,t),x)-2*_F2(x,t)*x*_F4(x,t)*diff(_F4(x,t),x)-2*_F2(x,t)*_F4(x,t)^2, diff(_F3(x,t),x)-2*_F3(x,t)*k*_F4(x,t)*diff(_F4(x,t),x)*t, diff(_F3(x,t),t)-_F3(x,t)*k*_F4(x,t)^2, _F4(x,t)^2-_F1(x,t), diff(_F4(x,t),t), diff(_F5(x,t),x), diff(_F6(x,t),x), diff(_F7(x,t),x), diff(_F5(x,t),t), diff(_F6(x,t),t), diff(_F7(x,t),t), diff(phi(x,t),t), diff(_F1(x,t),t), diff(_F2(x,t),t)]", "%t[%Az]", &eqns);

    ba0_init_table ((ba0_table)&ineqs);
    ba0_sscanf2 ("[_F2(x,t), _F2(x,t), _F3(x,t), _F4(x,t)]", "%t[%Az]", &ineqs);

    bad_init_splitting_control (&control);
    bad_init_intersectof_regchain (&ideal);
    ba0_sscanf2 ("intersectof_regchain ([], [differential, normalized])",
		 "%intersectof_regchain", &ideal);
    bad_Rosenfeld_Groebner (&ideal, &eqns, &ineqs, &K, &control);
    bad_remove_redundant_components_intersectof_regchain (&ideal, &ideal);

    ba0_sprintf (buffer, "%intersectof_regchain_equations", &ideal);

    b = b && ideal.inter.size == 0;
    return b ? 0 : 1;
}

