#include "bad.h"

int main ()
{
    bav_Iordering r;
    bap_tableof_polynom_mpz eqns;
    bad_intersectof_regchain T;
    struct ba0_mark M;
    char buffer [1024];
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);

    ba0_sscanf2 ("ordering (derivations = [], blocks = [[Da, Ma, A, E], _e])",
		 "%ordering", &r);
    bav_R_push_ordering (r);

    eqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ba0_sscanf2 ("[-Da*A - Da + 1, 50*Da - Ma, -5*Da*A + 5*Da + 25*Ma \
		    	- 25000*A*E - 6*A - 5, -500*A*E - 10*E + 1, \
			7*Da - 14*Ma - 4*A - 11*E + _e]", "%t[%Az]", eqns);

    T = bad_new_intersectof_regchain ();
    ba0_sscanf2
	("intersectof_regchain ([], [primitive, autoreduced, normalized])",
	 "%intersectof_regchain", T);

    bad_Rosenfeld_Groebner 
		(T, eqns, (bap_tableof_polynom_mpz)0, 
		 (bad_base_field)0, (bad_splitting_control)0);

    if (T->inter.size > 0)
	ba0_sprintf (buffer, "%regchain", T->inter.tab [0]);
    b = T->inter.size == 1 &&
	    strcmp (buffer, "regchain ([183750000*_e^3 - 122438739900*_e^2 - 4036616568040*_e + 1528236556973483, 251805729173030*E + 1341375000*_e^2 + 18868030500*_e - 16406489244853, 25180572917303*A + 4851000000*_e^2 - 3381158481110*_e + 54496930165326, 226625156255727*Ma - 13558125000*_e^2 - 7582268718450*_e - 129831547072705, 2266251562557270*Da - 2711625000*_e^2 - 1516453743690*_e - 25966309414541], [autoreduced, primitive, normalized])") == 0;

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
