#include "bad.h"

int main ()
{
    bav_Iordering r;
    bap_tableof_polynom_mpz eqns;
    bad_intersectof_regchain T;
    struct ba0_mark M;
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);

/*
 * test("posdim/8-3-config-Li.tst");
 */
    ba0_sscanf2 ("ordering (derivations = [], blocks = [x12, x11, x10 , x9, x8, x7, x6, x5, x4, x3, x2, x1])", "%ordering", &r);
    bav_R_push_ordering (r);

    eqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ba0_sscanf2 ("[x3*x12-x7*x8, x5*x11-x6*x10, x3*x10-x2*x10-x5*x8+x2*x8, x3*x9-x1*x9-x4*x8+x1*x8, x4*x11-x2*x11-x6*x9+x2*x9, x6*x12-x1*x12-x7*x11+x1*x11, x5*x12-x4*x12-x7*x10+x4*x10+x7*x9-x5*x9]", "%t[%Az]", eqns);

    T = bad_new_intersectof_regchain ();
    ba0_sscanf2
	("intersectof_regchain ([], [autoreduced, primitive])",
	 "%intersectof_regchain", T);

    bad_Rosenfeld_Groebner 
		(T, eqns, (bap_tableof_polynom_mpz)0, 
		 (bad_base_field)0, (bad_splitting_control)0);
/*
    ba0_printf ("number of components = %d\n", T->inter.size);

    Used to be 291.
    Then 46.
    With the dimension lower bound, 14.
*/
    bad_remove_redundant_components_intersectof_regchain (T, T);
    b = T->inter.size == 14;

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
