#include "bad.h"

int main ()
{
    bav_Iordering r;
    bap_tableof_polynom_mpz eqns;
    bad_intersectof_regchain T;
    struct ba0_exception_code code;
    struct ba0_mark M;
    bool b;

    bad_restart (10, 0);
    ba0_record (&M);
/*
 * Timeout is expected
 */
    BA0_PUSH_EXCEPTION(code);
    if (ba0_exception_is_raised (code))
    {	if (ba0_mesgerr == BA0_ERRALR)
	    return 0;
	BA0_RAISE_EXCEPTION (ba0_mesgerr);
    }

/*
 * test("posdim/MESFET-3.tst");
 */
    ba0_sscanf2 ("ordering (derivations = [], blocks = [x, y, z, t])", "%ordering", &r);
    bav_R_push_ordering (r);

    eqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ba0_sscanf2 ("[-4*y^2*x+4*x*y*z-3*x*z^2+22*y*t-22*z*t+261, 6*x^2*y^3+21*z*y^2*x^2+15*x^2*y*z^2+9*x^2*z^3-8*x*y^2*t-28*x*y*z*t+36*x*z^2*t-144*x*y-648*x*z-120, -15*x*y^3*t+15*x*y^2*z*t+40*y^2*t^2-80*y*z*t^2+40*z^2*t^2-81*y^2*x+216*x*y*z-162*x*z^2+1008*y*t-1008*z*t+5184, 9*x^2*y^4+30*x^2*y^3*z+39*x^2*y^2*z^2+18*x^2*y*z^3-24*x*y^3*t-16*x*y^2*z*t+16*x*y*z^2*t+24*x*z^3*t+16*y^2*t^2-32*y*z*t^2+16*z^2*t^2-432*y^2*x-720*x*y*z-432*x*z^2+576*y*t-576*z*t-240*y+5184]", "%t[%Az]", eqns);

    T = bad_new_intersectof_regchain ();
    ba0_sscanf2
	("intersectof_regchain ([], [autoreduced, primitive])",
	 "%intersectof_regchain", T);

    bad_Rosenfeld_Groebner 
	(T, eqns, (bap_tableof_polynom_mpz)0,
	 (bad_base_field)0, (bad_splitting_control)0);
/*
    ba0_printf ("number of components = %d\n", T->inter.size);
*/
    b = false;
    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
