#include "bad.h"

int main ()
{
    bav_Iordering r;
    bap_tableof_polynom_mpz eqns, ineqns;
    bad_intersectof_regchain T;
    struct ba0_exception_code code;
    struct ba0_mark M;
    bool b;

    bad_restart (0, 0);
/*
 * Timeout used to be expected
 */
    BA0_PUSH_EXCEPTION (code);
    if (ba0_exception_is_raised (code))
    {	if (ba0_mesgerr == BA0_ERRALR)
	    return 0;
	BA0_RAISE_EXCEPTION (ba0_mesgerr);
    }

    ba0_record (&M);
/*
 * subproblem of test("zerodim/Trinks-difficult.tst");
 *
 */
    ba0_sscanf2 ("ordering (derivations = [], blocks = [x,y,t,z,u,v])", 
			"%ordering", &r);
    bav_R_push_ordering (r);

    eqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ineqns = (bap_tableof_polynom_mpz)ba0_new_table ();
#undef EASY
#define EASY 1
#if defined (EASY)
    ba0_sscanf2 ("[-11*v^3+x*y+2*z*t,-11*u*v+3*v^2+99*x, 15*y*z+20*t*u-9*x]", "%t[%Az]", eqns);
#else
    ba0_sscanf2 ("[-11*v^3+x*y+2*z*t, -11*u*v+3*v^2+99*x, 15*y*z+20*t*u-9*x, 35*y+25*z+40*t-27*u, 45*y+35*u-165*v-36, 25*y*u-165*v^2+15*x-18*z+30*t]", "%t[%Az]", eqns);
#endif
    ba0_sscanf2 ("[x,v,y,z]", "%t[%Az]", ineqns);

    T = bad_new_intersectof_regchain ();
    ba0_sscanf2
	("intersectof_regchain ([], [primitive])",
	 "%intersectof_regchain", T);

    bad_Rosenfeld_Groebner 
	(T, eqns, ineqns, (bad_base_field)0, (bad_splitting_control)0);
/*
    ba0_printf ("%intersectof_regchain, number of components = %d\n", 
			T, T->inter.size);
*/
    b = T->inter.size == 1;
    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
