#include "bad.h"

/*
 * This test exhibited a bug (missing volatile qualifier).
 * The important issue, for this test, is that it terminates.
 */

int main ()
{
    bav_Iordering r;
    bap_tableof_polynom_mpz eqns;
    bad_intersectof_regchain T;
    struct ba0_mark M;
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);

    bad_reduction_strategy = bad_gcd_prem_and_factor_reduction_strategy;

    ba0_sscanf2 ("ordering (derivations=[], blocks= [[a,b,c,d,e]])",
		 "%ordering", &r);

    bav_R_push_ordering (r);
    eqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ba0_sscanf2 ("[a + b + c + d + e, a*b + b*c + c*d + d*e + e*a, a*b*c + b*c*d + c*d*e + d*e*a + e*a*b, a*b*c*d + b*c*d*e + c*d*e*a + d*e*a*b  + e*a*b*c]",
    		 "%t[%Az]", eqns);

    T = bad_new_intersectof_regchain ();
    ba0_sscanf2 
	("intersectof_regchain ([], [primitive])",
	 "%intersectof_regchain", T);

    bad_Rosenfeld_Groebner 
	(T, eqns, (bap_tableof_polynom_mpz)0, 
	 (bad_base_field)0, (bad_splitting_control)0);

    b = T->inter.size > 0;

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
