/* File serie_formelle.c */

#include "bad.h"

int main ()
{   bav_Iordering r;
    struct bap_tableof_polynom_mpz T;
    struct bap_tableof_ratfrac_mpz TNF;
    struct bap_ratfrac_mpz NF;
    struct bad_regchain C;
    struct ba0_mark M;
    bool ok;
    int i;

    bad_restart (0, 0);
    ba0_record (&M);

    ba0_sscanf2 ("ordering (derivations = [x, y], blocks = [[v, u]])",
		 "%ordering", &r);
    bav_R_push_ordering (r);

    bad_init_regchain (&C);
    ba0_sscanf2 
	("regchain ([v[x,x] - u[x], v[y] - u[x]*u[y]/4, \
		     u[x]^2 - 4*u, u[y]^2 - 2*u], [differential])", 
	 "%regchain", &C);

    ba0_init_table ((ba0_table)&T);
    ba0_sscanf2 ("[u, u[x], u[y], u[x,x], u[x,y], u[y,y], \
		   u[x,x,x], u[x,x,y], u[x,y,y], u[y,y,y], \
		   v, v[x], v[y], v[x,x], v[x,y], v[y,y], \
		   v[x,x,x], v[x,x,y], v[x,y,y], v[y,y,y], v[x,x,x,x], \
		   v[x,x,x,y], v[x,x,y,y], v[x,y,y,y], v[y,y,y,y]]", 
		 "%t[%Az]", &T);
    ba0_init_table ((ba0_table)&TNF);
    ba0_sscanf2 ("[u, u[x], u[y], 2, (u[x]*u[y])/(2*u), 1, 0, 0, 0, 0, \
		   v, v[x], (u[x]*u[y])/(4), u[x], u[y], (u[x])/(2), \
		   2, (u[x]*u[y])/(2*u), 1, (u[x]*u[y])/(4*u), 0, 0, 0, \
		   0, 0]", "%t[%Qz]", &TNF);

    bap_init_ratfrac_mpz (&NF);
    ok = true;
    for (i = 0; ok && i < T.size; i++)
    {   bad_normal_form_polynom_mod_regchain 
				(&NF, T.tab [i], &C, (bap_polynom_mpz*)0);
	ok = bap_equal_ratfrac_mpz (TNF.tab [i], &NF);
    }

    ba0_restore (&M);
    bad_terminate (ba0_init_level);
    return ok ? 0 : 1;
}
