#include "bai.h"

int main ()
{   struct bai_odex_system S;
    bav_Iordering r;
    FILE* f;
    FILE* g;

    bai_restart (0, 0);
    bai_init_odex_system (&S);
    ba0_sscanf2 ("ordering (derivations = [t], blocks = [[y0, y1], epsilon])",
		 "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_sscanf2 ("[y0, y1], [y1, epsilon*(1 - y0^2)*y1 - y0], [epsilon]", 
			"%t[%v], %t[%Qz], %t[%v]", &S.lhs, &S.rhs, &S.params);

    f = fopen ("new_vdp_C_code.out", "w");
    if (f == NULL) return 1;
    bai_odex_generate_rhs_C_code (f, "van_der_pol", &S);
    bai_odex_generate_jacobianof_rhs_C_code (f, "jac_vdp", &S);
    fclose (f);

    f = fopen ("vdp_C_code.out", "r");
    if (f == NULL) return 1;

    g = fopen ("new_vdp_C_code.out", "r");
    if (g == NULL) return 1;

    while (! feof (f) && ! feof (g))
	if (fgetc (f) != fgetc (g))
	    return 1;
    if (! feof (f) || ! feof (g))
	return 1;

    fclose (f);
    fclose (g);

    bai_terminate (ba0_init_level);
    return 0;
}
