#include "bap.h"

int main ()
{   bav_Iordering r;
    struct bap_polynom_mpq A, B, C;
    bav_variable x, y;
    bool b;
    static char buffer [1024];

    bap_restart (0, 0);
    ba0_sscanf2 
	("ordering (derivations = [], blocks = [x,y])", "%ordering", &r);
    bav_R_push_ordering (r);
    bap_init_polynom_mpq (&A);
    bap_init_polynom_mpq (&B);
    bap_init_polynom_mpq (&C);

    ba0_sscanf2 ("3*x*y - 7*x^2 - 8*x*y^2 + 5", "%Aq", &A);
    ba0_sscanf2 ("2*x-3/7", "%Aq", &B);
    ba0_sscanf2 ("x", "%v", &x);
    ba0_sscanf2 ("y", "%v", &y);

    bap_eval_polynom_polynom_mpq (&C, &A, y, &B);
    ba0_sprintf (buffer, "%Aq", &C);
    b = strcmp (buffer, "-32*x^3 + 89/7*x^2 - 135/49*x + 5") == 0;
    if (! b)
	return 1;

    bap_eval_polynom_polynom_mpq (&C, &A, x, &B);
    ba0_sprintf (buffer, "%Aq", &C);
    b = strcmp (buffer, "-28*x^2 - 16*x*y^2 + 6*x*y + 12*x + 24/7*y^2 - 9/7*y + 26/7") == 0;
    if (! b)
        return 1;

    bav_R_pull_ordering ();
    bap_terminate (ba0_init_level);
    return 0;
}
