#include "bap.h"

int main ()
{   struct bap_polynom_mpz A;
    struct bap_polynom_mpq Aq;
    struct bap_polynom_mint_hp Aim;
    bav_Iordering r;
    char buffer [256];

    bap_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [], blocks = [z,y,x])",
		 "%ordering", &r);
    bav_R_push_ordering (r);

    bap_init_polynom_mpz (&A);
    ba0_sscanf2 ("3*x*y - x*y^2 - 3 + z", "%expanded_Az", &A);
    ba0_sprintf (buffer, "%Az", &A);

    if (strcmp (buffer, "z - y^2*x + 3*y*x - 3") != 0)
	return 1;

    bap_init_polynom_mpq (&Aq);
    ba0_sscanf2 ("((3*x*y - x*y^2 - 3 + z))", "%expanded_Aq", &Aq);
    ba0_sprintf (buffer, "%Aq", &Aq);

    if (strcmp (buffer, "z - y^2*x + 3*y*x - 3") != 0)
	return 1;

    ba0_mint_hp_module_set (101, true);
    bap_init_polynom_mint_hp (&Aim);
    ba0_sscanf2 ("3*x*y + x*y^2 + 3 + z", "%expanded_Aim", &Aim);
    ba0_sprintf (buffer, "%Aim", &Aim);

    if (strcmp (buffer, "z + y^2*x + 3*y*x + 3") != 0)
        return 1;

    bap_terminate (ba0_init_level);
    return 0;
}
