#include "bap.h"

int main ()
{   bav_Iordering r;
    struct bap_polynom_mpz A;
    struct bap_product_mpz P;
    char buffer [256];
    bool b;

    bap_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [t], blocks = [x])", 
		 "%ordering", &r);
    bav_R_push_ordering (r);
    bap_init_polynom_mpz (&A);
    ba0_sscanf2 ("x^10 - 1", "%Az", &A);
    bap_init_product_mpz (&P);
    bap_factor_polynom_mpz (&P, &A);
    ba0_sprintf (buffer, "%Pz", &P);
    b = strcmp (buffer, "(x - 1)*(x + 1)*(x^4 + x^3 + x^2 + x + 1)*(x^4 - x^3 + x^2 - x + 1)") == 0;
    bap_terminate (ba0_init_level);
    return b ? 0 : 1;
}

