#include "bap.h"

int main ()
{   bav_Iordering r;
    struct bap_polynom_mpz A;
    struct bap_polynom_mpz B;
    struct bap_polynom_mpz G;
    struct bap_polynom_mpz cofA;
    struct bap_polynom_mpz cofB;
    bool b;

    bap_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [], blocks = [x2,x1,x0,d6,d2])", "%ordering", &r);
    bav_R_push_ordering (r);
    bap_init_polynom_mpz (&A);
    bap_init_polynom_mpz (&B);
    bap_init_polynom_mpz (&cofA);
    bap_init_polynom_mpz (&cofB);
    bap_init_polynom_mpz (&G);
    ba0_sscanf2 ("x2^6 - 3*x2^4*x1^2 - x2^4*x0^2 + 3*x2^4*d6^2 - 3*x2^4*d2^2 + 3*x2^2*x1^4 + 2*x2^2*x1^2*x0^2 - 6*x2^2*x1^2*d6^2 + 6*x2^2*x1^2*d2^2 - x2^2*x0^4 - 2*x2^2*x0^2*d6^2 + 2*x2^2*x0^2*d2^2 + 3*x2^2*d6^4 - 6*x2^2*d6^2*d2^2 + 3*x2^2*d2^4 - x1^6 - x1^4*x0^2 + 3*x1^4*d6^2 - 3*x1^4*d2^2 + x1^2*x0^4 + 2*x1^2*x0^2*d6^2 - 2*x1^2*x0^2*d2^2 - 3*x1^2*d6^4 + 6*x1^2*d6^2*d2^2 - 3*x1^2*d2^4 + x0^6 - x0^4*d6^2 + x0^4*d2^2 - x0^2*d6^4 + 2*x0^2*d6^2*d2^2 - x0^2*d2^4 + d6^6 - 3*d6^4*d2^2 + 3*d6^2*d2^4 - d2^6", "%Az", &A);
    ba0_sscanf2 ("7*x2^6 - 15*x2^4*x1^2 - 5*x2^4*x0^2 + 15*x2^4*d6^2 - 15*x2^4*d2^2 + 9*x2^2*x1^4 + 6*x2^2*x1^2*x0^2 - 18*x2^2*x1^2*d6^2 + 18*x2^2*x1^2*d2^2 - 3*x2^2*x0^4 - 6*x2^2*x0^2*d6^2 + 6*x2^2*x0^2*d2^2 + 9*x2^2*d6^4 - 18*x2^2*d6^2*d2^2 + 9*x2^2*d2^4 - x1^6 - x1^4*x0^2 + 3*x1^4*d6^2 - 3*x1^4*d2^2 + x1^2*x0^4 + 2*x1^2*x0^2*d6^2 - 2*x1^2*x0^2*d2^2 - 3*x1^2*d6^4 + 6*x1^2*d6^2*d2^2 - 3*x1^2*d2^4 + x0^6 - x0^4*d6^2 + x0^4*d2^2 - x0^2*d6^4 + 2*x0^2*d6^2*d2^2 - x0^2*d2^4 + d6^6 - 3*d6^4*d2^2 + 3*d6^2*d2^4 - d2^6", "%Az", &B);
/*

Calls the extended Zassenhaus gcd algorithm

A := 
x2^6 - 3*x2^4*x1^2 - x2^4*x0^2 + 3*x2^4*d6^2 - 3*x2^4*d2^2 + 3*x2^2*x1^4 + 2*x2
^2*x1^2*x0^2 - 6*x2^2*x1^2*d6^2 + 6*x2^2*x1^2*d2^2 - x2^2*x0^4 - 2*x2^2*x0^2*d6
^2 + 2*x2^2*x0^2*d2^2 + 3*x2^2*d6^4 - 6*x2^2*d6^2*d2^2 + 3*x2^2*d2^4 - x1^6 -
x1^4*x0^2 + 3*x1^4*d6^2 - 3*x1^4*d2^2 + x1^2*x0^4 + 2*x1^2*x0^2*d6^2 - 2*x1^2*
x0^2*d2^2 - 3*x1^2*d6^4 + 6*x1^2*d6^2*d2^2 - 3*x1^2*d2^4 + x0^6 - x0^4*d6^2 +
x0^4*d2^2 - x0^2*d6^4 + 2*x0^2*d6^2*d2^2 - x0^2*d2^4 + d6^6 - 3*d6^4*d2^2 + 3*
d6^2*d2^4 - d2^6:

B := 
7*x2^6 - 15*x2^4*x1^2 - 5*x2^4*x0^2 + 15*x2^4*d6^2 - 15*x2^4*d2^2 + 9*x2^2*x1^4 + 6*x2^2*x1^2*x0^2 - 18*x2^2*x1^2*d6^2 + 18*x2^2*x1^2*d2^2 - 3*x2^2*x0^4
 - 6*x2^2*x0^2*d6^2 + 6*x2^2*x0^2*d2^2 + 9*x2^2*d6^4 - 18*x2^2*d6^2*d2^2 + 9*x2
^2*d2^4 - x1^6 - x1^4*x0^2 + 3*x1^4*d6^2 - 3*x1^4*d2^2 + x1^2*x0^4 + 2*x1^2*x0^
2*d6^2 - 2*x1^2*x0^2*d2^2 - 3*x1^2*d6^4 + 6*x1^2*d6^2*d2^2 - 3*x1^2*d2^4 + x0^6
 - x0^4*d6^2 + x0^4*d2^2 - x0^2*d6^4 + 2*x0^2*d6^2*d2^2 - x0^2*d2^4 + d6^6 - 3*
d6^4*d2^2 + 3*d6^2*d2^4 - d2^6:

Unlucky evaluation

lifting polynomial = B

ideal := [x1 = 1, x0 = 0, d6 = 0, d2 = 1];

Ax := subs (op (ideal), A);
Bx := subs (op (ideal), B);
Gx := gcd (Ax, Bx);

p := 16777259;
l := 1;

factors_mod_point := [ Gx, quo (Bx, Gx, x2) ];

factors_mod_point := [x2^4 - 4*x2^2 + 4, 7*x2^2 - 2];
factors_initial := [1, 7];
*/
    bap_gcd_polynom_mpz (&G, &cofA, &cofB, &A, &B);
    bap_mul_polynom_mpz (&cofA, &cofA, &G);
    bap_sub_polynom_mpz (&cofA, &cofA, &A);
    b = bap_is_zero_polynom_mpz (&cofA);
    bap_mul_polynom_mpz (&cofB, &cofB, &G);
    bap_sub_polynom_mpz (&cofB, &cofB, &B);
    b = b && bap_is_zero_polynom_mpz (&cofB);
    bap_terminate (ba0_init_level);
    return b ? 0 : 1;
}

