#include "bap.h"

int main ()
{   bav_Iordering r;
    struct bap_polynom_mpz A;
    struct bap_polynom_mpz B;
    struct bap_polynom_mpz G;
    struct bap_polynom_mpz cofA;
    struct bap_polynom_mpz cofB;
    bool b;

    bap_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [x,y], blocks = [[u,v]])", "%ordering", &r);
    bav_R_push_ordering (r);
    bap_init_polynom_mpz (&A);
    bap_init_polynom_mpz (&B);
    bap_init_polynom_mpz (&cofA);
    bap_init_polynom_mpz (&cofB);
    bap_init_polynom_mpz (&G);
    ba0_sscanf2 ("u[y]*u - u[y]", "%Az", &A);
    ba0_sscanf2 ("-2*u[x,y]*v[y]*u[y] + 2*u[x,y]*u[x]*u - 2*u[x,y]*u[x] - 3*u[x]^2*u[y] - 2*u[y]*u + 2*u[y]", "%Az", &B);

    bap_gcd_polynom_mpz (&G, &cofA, &cofB, &A, &B);
    bap_mul_polynom_mpz (&cofA, &cofA, &G);
    bap_sub_polynom_mpz (&cofA, &cofA, &A);
    b = bap_is_zero_polynom_mpz (&cofA);
    bap_mul_polynom_mpz (&cofB, &cofB, &G);
    bap_sub_polynom_mpz (&cofB, &cofB, &B);
    b = b && bap_is_zero_polynom_mpz (&cofB);

    ba0_sscanf2 ("-8*v[y]*u[x]^2", "%Az", &A);
    ba0_sscanf2 ("4*u[x]^4 + 4*u[x]^2*u[y]^2 + 8*u[x]^2*u - 8*u[x]^2", "%Az", &B);
    bap_gcd_polynom_mpz (&G, &cofA, &cofB, &A, &B);
    bap_mul_polynom_mpz (&cofA, &cofA, &G);
    bap_sub_polynom_mpz (&cofA, &cofA, &A);
    b = b && bap_is_zero_polynom_mpz (&cofA);
    bap_mul_polynom_mpz (&cofB, &cofB, &G);
    bap_sub_polynom_mpz (&cofB, &cofB, &B);
    b = b && bap_is_zero_polynom_mpz (&cofB);

    bap_terminate (ba0_init_level);
    return b ? 0 : 1;
}

