#include "bap.h"

int main ()
{   struct bap_product_mpz G;
    struct bap_tableof_polynom_mpz T;
    bav_Iordering r;
    bool b;
    char buffer [4096];

    bap_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [x,y], blocks = [u,v])",
		 "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_init_table ((ba0_table)&T);
    bap_init_product_mpz (&G);

    ba0_sscanf2 ("[-v[x,x,y], -2]", "%t[%Az]", &T);
    bap_gcd_tableof_polynom_mpz (&G, &T, false);
    ba0_sprintf (buffer, "%Pz", &G);
    b = strcmp (buffer, "1") == 0;

    ba0_sscanf2 ("[-8, -2]", "%t[%Az]", &T);
    bap_gcd_tableof_polynom_mpz (&G, &T, false);
    ba0_sprintf (buffer, "%Pz", &G);
    b = b && strcmp (buffer, "2") == 0;

    ba0_sscanf2 ("[5*v[x,x,y]]", "%t[%Az]", &T);
    bap_gcd_tableof_polynom_mpz (&G, &T, false);
    ba0_sprintf (buffer, "%Pz", &G);
    b = b && strcmp (buffer, "5*v[x,x,y]") == 0;

    ba0_sscanf2 ("[0, 5*v[x,x,y]]", "%t[%Az]", &T);
    bap_gcd_tableof_polynom_mpz (&G, &T, false);
    ba0_sprintf (buffer, "%Pz", &G);
    b = b && strcmp (buffer, "5*v[x,x,y]") == 0;

    ba0_sscanf2 ("[0, 0, -v, 0]", "%t[%Az]", &T);
    bap_gcd_tableof_polynom_mpz (&G, &T, false);
    ba0_sprintf (buffer, "%Pz", &G);
    b = b && strcmp (buffer, "v") == 0;

    ba0_sscanf2 ("[0, -8, 0, 0]", "%t[%Az]", &T);
    bap_gcd_tableof_polynom_mpz (&G, &T, false);
    ba0_sprintf (buffer, "%Pz", &G);
    b = b && strcmp (buffer, "8") == 0;
/*
    printf ("%s\n", buffer);
 */
    bap_terminate (ba0_init_level);
    return b ? 0 : 1;
}

