#include "bap.h"

int main ()
{
    bav_Iordering r, s;
    struct bap_ratfrac_mpz Q, R, S;
    char buffer [256];

    bap_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [x,y], blocks = [u, v])",
		 "%ordering", &r);
    ba0_sscanf2 ("ordering (derivations = [y,x], blocks = [u, v])",
		 "%ordering", &s);

    bav_R_push_ordering (r);
    bap_init_ratfrac_mpz (&Q);
    bap_init_ratfrac_mpz (&R);
    bap_init_ratfrac_mpz (&S);

    ba0_sscanf2 ("u[x] +v/u[y]", "%Qz", &Q);
    bap_separant_ratfrac_mpz (&S, &Q);
    ba0_sprintf (buffer, "%Qz", &S);
    if (strcmp (buffer, "1") != 0)
	return 1;
    bav_R_push_ordering (s);
    bap_sort_ratfrac_mpz (&R, &Q);
    bap_separant_ratfrac_mpz (&S, &R);
    ba0_sprintf (buffer, "%Qz", &S);
    if (strcmp (buffer, "(-v)/(u[y]^2)") != 0)
	return 1;
    bav_R_pull_ordering ();
    bav_R_pull_ordering ();
    bap_terminate (ba0_init_level);
    return 0;
}
