#include "bap.h"

int main ()
{   bav_Iordering r, s;
    bav_variable v;
    struct bap_polynom_mpz A, B;
    char buffer [64];
    bool b;

    bap_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [], blocks = [z,t,u,v])",
		 "%ordering", &r);
    bav_R_push_ordering (r);

    bap_init_polynom_mpz (&A);
    ba0_sscanf2 ("v, 297*z^2 - 22*u^2*v + 6*u*v^2", "%v, %Az", &v, &A);

    s = bav_R_copy_ordering (bav_R_Iordering ());
    bav_R_push_ordering (s);
    bav_R_set_maximal_variable (v);
    
    bap_init_readonly_polynom_mpz (&B);
    bap_sort_polynom_mpz (&B, &A);

    ba0_sprintf (buffer, "%Az", &B);

    b = strcmp (buffer, "6*v^2*u - 22*v*u^2 + 297*z^2") == 0;

    bav_R_pull_ordering ();
    bav_R_free_ordering (s);

    bap_terminate (ba0_init_level);
    return b ? 0 : 1;
}
