#ifndef BAV_ORDERING_H
#define BAV_ORDERING_H 1

#include "bav_common.h"
#include "bav_symbol.h"
#include "bav_block.h"
#include "bav_variable.h"
#include "bav_operator.h"

BEGIN_C_DECLS

typedef struct bav_ordering {
    struct bav_tableof_symbol ders;
    struct bav_tableof_block blocks;
    struct bav_block operator_block;
    struct bav_tableof_variable varmax;
} *bav_ordering;

typedef struct bav_tableof_ordering {
    ba0_int_p alloc;
    ba0_int_p size;
    bav_ordering *tab;
} *bav_tableof_ordering;

extern BAV_DLL void bav_set_settings_ordering (char*);
extern BAV_DLL void bav_get_settings_ordering (char**);
extern BAV_DLL void bav_init_ordering (bav_ordering);
extern BAV_DLL void bav_reset_ordering (bav_ordering);
extern BAV_DLL bav_ordering bav_new_ordering (void);
extern BAV_DLL void bav_set_ordering (bav_ordering, bav_ordering);

extern BAV_DLL ba0_scanf_function bav_scanf_ordering;
extern BAV_DLL ba0_printf_function bav_printf_ordering;

END_C_DECLS

#endif /* !BAV_ORDERING_H */

