#ifndef BAV_SUBRANKING_H
#define BAV_SUBRANKING_H 1

#include "bav_common.h"
#include "bav_variable.h"

BEGIN_C_DECLS

typedef ba0_int_p bav_subranking;

struct bav_subranking {
   char* ident;
   bool (*inf) (bav_variable, bav_variable, 
		ba0_int_p, ba0_int_p, bav_tableof_symbol);
};

extern BAV_DLL bool bav_is_subranking (char*, bav_subranking*);

/*
 * Readonly data structure used also in bav_block.
 */

extern BAV_DLL struct bav_subranking bav_subranking_table [];

END_C_DECLS
#endif /* !BAV_SUBRANKING_H */
