#include "bav.h"

char ORDG [] = "ordering (derivations = [x,y], blocks = [u,v], varmax = [v[x,y]])";

int main ()
{   bav_Iordering r;
    static char buffer [256];
    struct bav_ev_point E;

    bav_restart (0, 0);
    ba0_sscanf2 (ORDG, "%ordering", &r);

    bav_init_ev_point (&E);
    bav_realloc_ev_point (&E, 3);
    ba0_sscanf2 ("x = 13", "%v = %d", &E.tab [0].var, &E.tab [0].value);
    ba0_sscanf2 ("u[x] = 3", "%v = %d", &E.tab [1].var, &E.tab [1].value);
    ba0_sscanf2 ("v[x,y]  = -5", "%v = %d", &E.tab [2].var, &E.tab [2].value);
    E.size = 3;
    
    ba0_sprintf (buffer, "%ev_point", &E);
    if (strcmp (buffer, "[x = 13, u[x] = 3, v[x,y] = -5]") != 0)
	return 1;

    bav_terminate (ba0_init_level);
    return 0;
}

