#include "bav.h"

int main ()
{   struct bav_tableof_variable T, U;
    bav_Iordering r;
    bav_variable v;
    ba0_int_p i;
    char buffer [512];
    bool b;

    bav_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [x,y], blocks = [u])",
		 "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_init_table ((ba0_table)&U);

    ba0_init_table ((ba0_table)&T);
    ba0_realloc_table ((ba0_table)&T, 20);

    ba0_sscanf2 ("u", "%v", &v);
    for (i = 0; i < 20; i++)
    {	T.tab [T.size++] = v;
	v = bav_next_derivative (v, &U);
    }

    ba0_sprintf (buffer, "%t[%v]", &T);
    b = strcmp (buffer, "[u, u[y], u[x], u[y,y], u[x,y], u[x,x], u[y,y,y], u[x,y,y], u[x,x,y], u[x,x,x], u[y,y,y,y], u[x,y,y,y], u[x,x,y,y], u[x,x,x,y], u[x,x,x,x], u[y,y,y,y,y], u[x,y,y,y,y], u[x,x,y,y,y], u[x,x,x,y,y], u[x,x,x,x,y]]") == 0;

    T.size = 0;
    ba0_sscanf2 ("[u[x,y]]", "%t[%v]", &U);
    ba0_sscanf2 ("u", "%v", &v);
    for (i = 0; i < 10; i++)
    {   T.tab [T.size++] = v;
	v = bav_next_derivative (v, &U);
    }

    ba0_sprintf (buffer, "%t[%v]", &T);
    b = b && strcmp (buffer, "[u, u[y], u[x], u[y,y], u[x,x], u[y,y,y], u[x,x,x], u[y,y,y,y], u[x,x,x,x], u[y,y,y,y,y]]") == 0;

    T.size = 0;
    ba0_sscanf2 ("[u[x,x], u[y,y,y]]", "%t[%v]", &U);
    ba0_sscanf2 ("u", "%v", &v);
    for (i = 0; i < 20 && v != BAV_NOT_A_VARIABLE; i++)
    {   T.tab [T.size++] = v;
        v = bav_next_derivative (v, &U);
    }

    b = b && v == BAV_NOT_A_VARIABLE;

    bav_terminate (ba0_init_level);
    return b ? 0 : 1;
}
