#include "bav.h"

char* input [] = {
   "ordering (derivations = [t], blocks = [[u,v],grlexB[w]])",
   "ordering (derivations = [t], blocks = [w,v,u])",
   "ordering (derivations = [x,y], blocks = [degrevlexA[u]], operator = [D], varmax = [u[x,x]])",
   "ordering (derivations = [y,x], blocks = [u], operator = [D], varmax = [u[x], u[y,y,y]])"
};

char* output [] = {
    "ordering (derivations = [t], blocks = [grlexA[u, v], grlexB[w]])",
    "ordering (derivations = [t], blocks = [grlexA[w], grlexA[v], grlexA[u]])",
    "ordering (derivations = [x, y], blocks = [degrevlexA[u]], operator = grlexA[D], varmax = [u[x,x]])",
    "ordering (derivations = [y, x], blocks = [grlexA[u]], operator = grlexA[D], varmax = [u[x], u[y,y,y]])"
};

int main ()
{   bav_Iordering r;
    static char buffer [256];
    bool b;
    int i;

    bav_restart (0, 0);
    b = true;
    for (i = 0; i < sizeof (input) / sizeof (*input) && b; i++)
    {	if (i == 2)
	{   bav_terminate (ba0_reset_level);
	    bav_restart (0, 0);
	}
	ba0_sscanf2 (input [i], "%ordering", &r);
	ba0_sprintf (buffer, "%ordering", r);
	b = strcmp (output [i], buffer) == 0;
    }
    bav_terminate (ba0_init_level);
    return b ? 0 : 1;
}

