#include "bav.h"

char* input [] = {
   "ordering (derivations = [t], blocks = [[u[1],v],grlexB[w[[2]]]])",
   "ordering (derivations = [t], blocks = [w,v[-4],u])",
   "ordering (derivations = [x,y[3]], blocks = [degrevlexA[u]], operator = [D[1]], varmax = [u[x,x]])",
   "ordering (derivations = [y,x[3]], blocks = [u[1]], operator = [D], varmax = [u[1][x[3]], u[1][y,y,y]])"
};

char* output [] = {
    "ordering (derivations = [t], blocks = [grlexA[u[1], v], grlexB[w[[2]]]])",
    "ordering (derivations = [t], blocks = [grlexA[w], grlexA[v[-4]], grlexA[u]])",
    "ordering (derivations = [x, y[3]], blocks = [degrevlexA[u]], operator = grlexA[D[1]], varmax = [u[x,x]])",
    "ordering (derivations = [y, x[3]], blocks = [grlexA[u[1]]], operator = grlexA[D], varmax = [u[1][x[3]], u[1][y,y,y]])"
};

int main ()
{   bav_Iordering r;
    static char buffer [256];
    bool b;
    int i;

    b = true;
    for (i = 0; i < sizeof (input) / sizeof (*input) && b; i++)
    {	
	bav_restart (0, 0);
	ba0_sscanf2 (input [i], "%ordering", &r);
	ba0_sprintf (buffer, "%ordering", r);
	b = strcmp (output [i], buffer) == 0;
	bav_terminate (ba0_init_level);
    }
    return b ? 0 : 1;
}

