#include "bav.h"

int main ()
{   bav_Iordering r;
    static char buffer [256];
    struct bav_tableof_variable T;
    struct ba0_mark M;
    ba0_int_p i;

    bav_restart (0, 0);

    ba0_sscanf2 
	("ordering (derivations = [x,y], blocks = [u,v,w,z])", 
	 "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_record (&M);

    ba0_sscanf2 ("[u(x), v, w(y,x)]", "%t[%param]", &bav_parameters);

    ba0_init_table ((ba0_table)&T);
    ba0_sscanf2 ("[u, x, v, w, z]", "%t[%v]", &T);

    bav_set_settings_variable (0, &bav_printf_diff_variable, 0);
    ba0_sprintf (buffer, "%t[%v]", &T);

    if (strcmp (buffer, "[u(x), x, v, w(y,x), z(x,y)]") != 0)
	return 1;

    ba0_sscanf2 ("[u[x], w[y], z[x,y]]", "%t[%v]", &T);
    for (i = 0; i < T.size; i++)
	if (bav_is_zero_derivative_of_parameter (T.tab [i], &bav_parameters))
	    return 1;

    ba0_sscanf2 ("[u[y], u[x,x,y], v[x]]", "%t[%v]", &T);
    for (i = 0; i < T.size; i++)
        if (! bav_is_zero_derivative_of_parameter (T.tab [i], &bav_parameters))
            return 1;

    ba0_restore (&M);

    bav_R_pull_ordering ();
    bav_terminate (ba0_init_level);
    return 0;
}

