#include "bav.h"

int main ()
{   struct ba0_stack H;
    struct bav_differential_ring R;
    bav_Iordering r;
    bav_term T;
    struct ba0_mark M;
    ba0_int_p size;
    void* cell;
    char buffer [256];

    bav_restart (0, 0);

    ba0_sscanf2
        ("ordering (derivations = [x,y], blocks = [u,v], varmax = [v[x,y]])",
         "%ordering", &r);
    bav_R_push_ordering (r);

    T = bav_new_term ();
    ba0_sscanf2 ("u[x]*v[x]*u[x]*x*u", "%term", T);
    ba0_sprintf (buffer, "%term", T);
    if (strcmp (buffer, "u[x]^2*u*v[x]*x") != 0)
        return 1;

    ba0_record (&M);

    cell = (void*)malloc (bav_sizeof_differential_ring (&bav_R));
    size = bav_sizeof_differential_ring (&bav_R);
    ba0_init_one_cell_stack (&H, "local stack", cell, size);
    ba0_push_stack (&H);
    bav_init_differential_ring (&R);
    bav_set_differential_ring (&R, &bav_R);
    ba0_pull_stack ();

    ba0_push_stack (&ba0_quiet_stack);
    bav_R_init ();
    bav_set_differential_ring (&bav_R, &R);
    ba0_pull_stack ();

    ba0_restore (&M);

    T = bav_new_term ();
    ba0_sscanf2 ("u[x]*v[x]*u[x]*x*u", "%term", T);
    ba0_sprintf (buffer, "%term", T);
    if (strcmp (buffer, "u[x]^2*u*v[x]*x") != 0)
        return 1;

    ba0_clear_one_cell_stack (&H);
    bav_terminate (ba0_init_level);
    free (cell);

    return 0;
}
