#include "bap.h"

/*
  Another small (but multivariate) example.
*/

int main ()
{   bav_Iordering r;
    struct bap_polynom_mpz A;
    struct bap_product_mpz P;

    bap_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [], blocks = [x,y])", "%ordering", &r);
    bav_R_push_ordering (r);
    bap_init_polynom_mpz (&A);
    ba0_sscanf2 ("(x^7*y + 12345*y^2 - 37*x)*(x*y - 17*x^5)", "%Az", &A);
    bap_init_product_mpz (&P);
    bap_factor_polynom_mpz (&P, &A);
    ba0_printf ("factor (%Az) = %Pz\n", &A, &P);
    bap_terminate (ba0_init_level);
    return 0;
}

